#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include "qfxptr.h"

#define RETITM  39

static long MACT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MDRAW (struct WM_wwork *wwk, struct WM_menw *mw);

static struct WM_action mdraw = {JSR, wm_drwaw, MDRAW};
static struct WM_action mact = {JSR, wm_actme, MACT};

#define MAX_SECT    1
#define MAX_YSIZE   120

#define ninfw   3
#define ninfo   1
#define nlitm   1
#define nappl   1

static WM_PWCB (2) pwcy = {0};

static QD_TEXTI (PROMPT, "QFAX View ");

static long MESC (struct WM_wwork *wwk, struct WM_litm *li);

static struct WM_action mesc = {JSR, wm_actli, MESC};

static QD_TEXTI (ESCAPE, "Quit");

static struct WM_info info[] =	/* information objects */
{
    {60, 10,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     TYP_TEXT, 0,		/* type, spare          item type */
     {0, 0, 0}, 		/* ink, cwid, chgt      character attributes */
     &PROMPT},			/* *pobj                pointer to object */
    {-1}
};

static struct WM_infw infw[] =
{
    {0, 14,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 127,			/* borw, borc, papr     border width/clr, paper */
     NULL},			/* *pobj                pointer to object list */

    {66, 10,			/* xsize, ysize         size */
     4, 2,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     1, 255, 7,   		/* borw, borc, papr     border width/clr, paper */
     info},			/* *pobj                pointer to object list */

    {24, 10,			/* xsize, ysize         size */
     200, 2,			/* xorg, yorg           and origin */
     0,
     1,255,7, NULL},

    {-1}
};

static struct WM_menw mw =	/* menu window */
{
    0, 0,			/* xsize, ysize         size */
    2, 14,			/* xorg, yorg           and origin */
    0,  			/* flag                 no clear + shadow */
    1, 0, 7,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &mdraw,			/* *draw                draw routine */
    wm__mhit,			/* *hit                 hit routine */
    wm__pnsc,			/* *ctrl                control routine */
    0, MAX_SECT,		/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
   /*2, 0, 7,*/0,7,0,	        /* psac, psbc, pssc arrow/bar clrs */
    (WM_pwcb_t *) &pwcy,	/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
   /*2, 0, 7,*/0,7,0,            	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *mstt                menu status area */
    1, 0,			/* curw, curc           current item width/clr */
    7, 2, NULL, NULL,	/* uback, uink, *ublob, *upatt unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    0, 7, NULL, NULL,	/* sback, sink, *sblob, *spatt selected */
    1, 0,			/* ncol, nrow           columns and rows */
    0, 0,			/* xoff, yoff           window offset */
    {0, 0},			/* -xsize, -xspce     or *xspc spacing list */
    {-10, -12},			/* -ysize, -yspce     or *yspc spacing list */
    NULL, NULL,			/* *xind, *yind         not implemented */
    NULL			/* *rowl                row list */
};

static struct WM_litm plitm[] =	/* loose item */
{
    {24, 10,			/* xsize, ysize         size */
     200, 2,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, 3,		/* type, skey           type and select key */
     &ESCAPE,			/* *pobj                pointer to object */
     0,				/* item                 item number */
     &mesc},			/* *pact                pointer to action */
    {-1}
};

struct WM_appl appl[] = {(WM_appw_t *) &mw, NULL};

static struct WM_wwork ww =	/* window working definition */
{
    NULL,			/* *wstat;              pointer to status area */
    NULL,			/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst               pointer to sprite list */
    0, 0,			/* xsize, ysize will need changing */
    4, 23,			/* xorg, yorg           and origin */
    2 | NO_WCLEAR,		/* flag                 no clear + shadow */
    1, 0, 255,    		/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,			/* curw, curc           current item width/clr */
    7, 2, NULL, NULL,	/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,	/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,	/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, plitm,		/* nlitm, *plitm        loose items */
    nappl, appl			/* nappl  *pappl        appl winds */
};
    
static struct WM_wstat ws = {0};

#define MAXX 400
#define MAXY 200

static long lit_reset (struct WM_wwork *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;	/* set make available */
    return wm_ldraw (wwk, -1);	/* and re-draw */

}

int menu (PLLIST *MList, short icount, short mono)
{
    int rval;
    short flg = 0;
    int xsize = 0, ysize = 0;

    ww.chid = io_open("con", 0);

    if(ww.chid < 0)
    {
        return -1;
    }

    if (!(wm_findv (ww.chid)))
    {
        return -1;
    }

    ws.wmode = FORM_QL4;
    ws.wwork = &ww;		/* cross references */
    ww.wstat = &ws;

    ysize = icount * 12;

    if(ysize > MAXY - 18)
    {
        ysize = 12*((MAXY - 18)/12) ;
        flg = 1;
    }

    xsize = (((PMDEF) (*MList)->item)->qtext->len) * 6 + 12 +flg*8;
    if(xsize > MAXX - 12)
    {
        xsize = MAXX - 12;
    }
    
    LoadMenu (&mw, (*MList), &mact);

    infw[0].xsize = xsize;
    ww.xsize = xsize;
    mw.xsize = xsize - 4;

    mw.ysize = ysize;

    ww.ysize = 15 + mw.ysize;
    mw.xs.c._size = -mw.xsize + 4;
    mw.xs.c._spce = -mw.xsize;

    ws.citem = -1;		/* no current item  */

    infw[2].xorg = plitm[0].xorg = xsize - plitm[0].xsize - 6;

    if(!mono)
    {
        mw.ypsac = 2;
        mw.sback = 2;
        mw.sink = 7;
        mw.curc = 2;
        mw.borc = 255;        
        infw[0].papr = 84;
    }

    wm_prpos (&ww, -1, -1);	/* pull down */
    wm_wdraw (&ww);

    while (!wm_rptr (&ww))
    {
	if (ws.evnt & PT_CAN)
	    break;
	if(ws.evnt & PT_WMOVE)
	{
	    menu_rems(&mw);
            LoadMenu (&mw, (*MList), &mact);
	    wm_swapp(&ww, 0, -1);
    	    sd_clear(ww.chid, -1);
	    MDRAW(&ww, &mw);
	}
    }

    rval = ws.litem[RETITM];
    return rval;
}

static long MDRAW (struct WM_wwork *wwk, struct WM_menw *mw)
{
    menu_chks (mw);
    wm_index (wwk, (struct WM_swdef *) mw);
    wm_mdraw (wwk, (struct WM_swdef *) mw, 0);
}

static long MACT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;	/* current menu object */
    wwk->wstat->litem[RETITM] = mobj->item;
    return PT__CAN;
}
static long MESC (struct WM_wwork *wwk, struct WM_litm *li)
{
    wwk->wstat->litem[RETITM] = -1;
    lit_reset (wwk, li->item);
    return PT__CAN;		/* and return CAN event */
}
