#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <qdos.h>
#include <sms.h>
#include <time.h>
#include <things.h>
#include "qheader.h"

void (*_SigStart)(void) = NULL;

typedef union {
    char txt[4];
    long x;
 } ALIGN;

typedef struct
{
    char path[40];
    time_t stamp;
} FAXITEM;

typedef struct
{
    int flag;
    int type;
    short maxitems;
    short current;
    short nitems;
    FAXITEM fdata[1];
} FAX_LIST;

#define TEST_ID  0x302e3031	/* 0.01 */

char _prog_name[] = "QFAX \"NT\"";

/*
 * Let's just have one of these
 */

static char *Stuff = "QFAX Items";
static ALIGN thh = {THH_FLAG};
#define STUFF_SIZE 10

static void * thg_malloc(long n, jobid_t j)
{
    void *p;
    long dummy;
    p = sms_achp (n, &dummy, j);
}

static void * thg_free(void *p)
{
    sms_rchp (p);
}			     
static int AddThing (short items,  THING_LINKAGE **p)
{
    int m, n;
    int size;
    int sts;

    /*
     * size = size of a linkage block plus the length of the name
     */

    size = (offsetof (THING_LINKAGE, th_name_text) + STUFF_SIZE );

    /*
     * Make one allocation for both linkage block and data
     * Owned by job zero, so it says when the program terminates
     * If the linkage is owned by the job, QDOS will tidy up for us 
     */

    m = size + sizeof (FAX_LIST) + (items - 1) * sizeof (FAXITEM);
    *p = (THING_LINKAGE *) thg_malloc (m, 0);

    if (*p)
    {
	/*
	 * Got some memory, so define our thing. We have to set the id
	 * the name (and length) and thing address in the linkage block
	 * and the header info in the thing itself. We also preset the
	 * data in the thing.
	 */

	(*p)->th_name = STUFF_SIZE;
	memcpy ((*p)->th_name_text, Stuff, STUFF_SIZE);
	(*p)->th_verid = TEST_ID;

	/*
	 * This is where the thing starts.
	 */

	(*p)->th_thing = ((char *) (*p) + size);

	((FAX_LIST *) (*p)->th_thing)->flag = thh.x;
	((FAX_LIST *) (*p)->th_thing)->type = THT_DATA;

	((FAX_LIST *) (*p)->th_thing)->maxitems = items;
	((FAX_LIST *) (*p)->th_thing)->current = 0;
	((FAX_LIST *) (*p)->th_thing)->nitems = 0;

	sts = sms_lthg (*p);
	if (sts != 0)
	{
	    thg_free (*p);
	    *p = NULL;
	}
    }
    return sts;
}
static int slurp (char **pr, int nc)
{
    char *r = *pr;

    for (; nc && *r == ' '; r++, nc--)
	;
    *pr = r;
    return nc;
}

#define KILL 1
#define LOAD 2
#define SAVE 3
#if 0
#include <stdio.h>
#include <stdarg.h>
void Report (char *ctl,...)
{
    va_list va;
    char t[80];

    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);
    io_sstrg (0x00010001, -1, t, strlen (t));
}
#endif

main (int ac, char **av)
{
    THING_LINKAGE *p = NULL;
    int sts;
    char *sp;
    short nc;
    int ch, n;
    int nitems = 0;
    char fnam[40];
    static short thgdef[3] = {0, 0, 0};
    int chid = 0;
    long vers;
    short act = 0;

    fnam[0] = 0;

    sp = *(av + 1);
    nc = *((short *) (sp));

    sp += 2 + nc * 4;
    nc = *((short *) (sp));

    if (nc)
    {
	char *s, *r;

	if (nc = ((struct QLSTR *) sp)->qs_strlen)
	{
	    s = ((struct QLSTR *) sp)->qs_str;
	    nc = slurp (&s, nc);

	    if (strncasecmp (s, "kill", 4) == 0)
	    {
		act = KILL;
	    }
	    else if (strncasecmp (s, "load", 4) == 0
		     || strncasecmp (s, "save", 4) == 0)
	    {
		act = (*s & 1) ? SAVE : LOAD;
		s += 4;
		nitems = strtol (s, &r, 0);
		nc = nc - (r - s);
		nc = slurp (&r, nc);
		if (nc)
		{
		    memcpy (fnam, r, nc);
		    *(fnam + nc) = 0;
		}
	    }
	}
    }

    if (act == KILL)
    {
	sts = sms_rthg (Stuff);
    }
    else
    {
	sts = (int) sms_uthg (Stuff, -1, -1, NULL, NULL, &vers, &p);

	if (act == LOAD)
	{
	    if (sts == ERR_NF)
	    {
		if (nc)
		{
		    if ((chid = io_open (fnam, 0)) > 0)
		    {
			int thgs[2];

			if (io_fstrg (chid, -1, thgs, sizeof (thgs)) > 0)
			{
			    if (thgs[0] == thh.x && thgs[1] == THT_DATA)
			    {
				io_fstrg (chid, -1, thgdef, sizeof (thgdef));
			    }
			}
		    }
		    else
		    {
			sts = ERR_NF;
		    }
		}
		if (nitems <= 0)
		{
		    if (thgdef[0])
		    {
			nitems = thgdef[0];
		    }
		    else
		    {
			nitems = 20;
		    }
		}
		sts = AddThing (nitems, &p);
		if (chid > 0)
		{
		    short i, j, k;
		    FAX_LIST *f = (FAX_LIST *) p->th_thing;

		    if (thgdef[2] > nitems)
		    {
			k = nitems;
			fs_pos (chid, (thgdef[2] - nitems) * sizeof (FAXITEM), 1);
		    }
		    else
		    {
			k = thgdef[2];
		    }

		    f->nitems = k;
		    f->current = k % nitems;

		    for (i = 0; i < k; i++)
		    {
			io_fstrg (chid, -1, &(f->fdata[i]),
				  sizeof (FAXITEM));
		    }
		}
	    }
	}
	else if (act == SAVE && sts >= 0)
	{
	    if (nc)
	    {
		int chid;
		short i, pos;
		FAX_LIST *f = (FAX_LIST *) p->th_thing;

		/* Do this a la QDOS for minimal size in other apps. */

		pos = f->current;
		if ((chid = io_open (fnam, 3)) > 0)
		{
		    /* for convenience of loading, the list is saved
		       in chronlogical order (current == nitems)
                     */
		    io_sstrg (chid, -1, f, (2 * sizeof (int) + sizeof (short)));
		    io_sstrg (chid, -1, &f->nitems, sizeof (short));
		    io_sstrg (chid, -1, &f->nitems, sizeof (short));

		    for (i = 0; i < f->nitems; i++, pos++)
		    {
			pos = pos % f->nitems;
			io_sstrg (chid, -1, &(f->fdata[pos]), sizeof (FAXITEM));
		    }
		    io_close (chid);
		}
	    }

	}
        if(sts >= 0)
        {
	    sms_fthg (Stuff, -1, NULL, 0, NULL, NULL);
	}
    }
    return (sts < 0) ? sts : 0;
}
int (*_Cstart) (int, char **) = main;

