#include <stdio.h>
#include <time.h>
#include <fcntl.h>
#include "qheader.h"

/*
        Bytes 0 - 4 : title  -> "ZyXEL"
        Byte  5     : 0
        Byte  6 - 7 : version number
        Byte  8 - 9 : reserved
        Bytes 10-11 : Page scan width, A4=1728.
        Bytes 12-13 : page count, pages number in this file
        Bytes 14-15 : Resolution and coding scheme,
                        0 - 1-D Normal
                        1 - 1-D High
                        2 - 2-D Normal
                        3 - 2-D High

*/

void SetHeader (QFAXHEADER * h, 
                  short wd, short vr, short df, short ln, short pcnt, short lsb)
{
    if (h)
    {
        memset (h, 0, QFAXHEADLEN);
        printf("wid %d vres %d cod %d ln %d page %d\n",
            wd,vr,df,ln,pcnt);
	h->title = QFAXTITLE;
	h->version = QFAXVERS;
	h->width = wd;
	h->resolution = vr;
	h->coding = df;
	h->page = ln;
	strcpy (h->tsi, "ZFAX->QFAX");
	h->stamp = time(NULL);
	h->pagemax = pcnt;
	h->hint = 0;
	h->lsb = lsb;
        h->offset = 0;
    }
}
short toshort(unsigned char *z)
{
    short sval;
    sval = *z | (*(z+1) << 8);
    return sval;
}
int main(int ac, char **av)
{
    int fd1, fd2;
    if((fd1 = open(av[1], O_RDONLY)) > 0)
    {
        if((fd2 = open(av[2], O_CREAT | O_WRONLY, 0x666)) > 0)
        {
	    unsigned char zbuf[512];
            QFAXHEADER h;
            short px,pcnt,res,cod,n, lsb;
            
	    read(fd1, zbuf, 16);
            {
                char c;
                while(read(fd1, &c, 1) == 1 && c == 0)
                    ;
                lseek(fd1, 16, 0);
                if(c & 0x80)
                {
                    lsb = 1;
		}
                else
                {
                    lsb = 0;
		}    
            }
	    px = toshort(zbuf+10);
	    pcnt = toshort(zbuf+12);
	    res = toshort(zbuf+14);
	    cod = res >> 1;
	    res &= 1;
	    if(px == 1728)
	    {
	        px = 0;
	    }
	    else if (px == 2432)
	    {
	        px = 1;
	    }
	    else
	    {
	        px = 2;
	    }

	    SetHeader(&h,  px, res, cod, 2, pcnt, lsb);
            write(fd2, &h, sizeof(h));
	    while((n = read(fd1, zbuf, 512)) > 0)
	    {
	        write(fd2, zbuf, n);
	    }
            close(fd2);
        }
	close(fd1);
    }
    return 0;
}
