#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <fcntl.h>
#include <unistd.h>

#include "qfv.h"

static short xinc, nc, lim;
void ShowHelp (void)
{
    if (pv->interact & 1)
    {
	fputs ("printfax  -o device [-t type]  [-c N] [-s N] files\n", stderr);
	fputs ("types are: \n", stderr);
	ListXPL(stderr,"                    %-10.10s\n");
    }
}

void Report (char *ctl,...)
{
    if (pv->interact & 1)
    {
	va_list va;
	va_start (va, ctl);
	vprintf (ctl, va);
	va_end (va);
	fputc ('\n', stdout);
    }
}

void Warning (char *ctl,...)
{
    if (pv->interact & 1)
    {
	va_list va;
	va_start (va, ctl);
	vprintf (ctl, va);
	va_end (va);
	fputc ('\n', stdout);
    }
}

void ShowSize (void)
{
    if (pv->interact & 1)
    {
	nc = lim = 0;
#ifndef __NT__
	printf ("(%41.41s)\r(", "");
	fflush (stdout);
#endif
	xinc = pv->xline / 40;
    }
}
void ShowPlace (int i)
{
    if (pv->interact & 1)
    {
	if (i >= lim && nc <= 40)
	{
#ifdef __NT__
	    printf("%3d%%\r", nc * 5/2);
#else
	    fputs ("\x1b[43m \x1b[0m", stdout);
#endif
	    nc++;
	    lim += xinc;
	    fflush (stdout);
	}
    }
}



