#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdarg.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>
#include <unistd.h>

#include "qfv.h"

struct WINDOWDEF _condetails = {6, 1, 0, 6, 364, 65, 60, 60};
long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
int (*_conread)  (struct UFB *, void *, unsigned int) = NULL;
int (*_conwrite)  (struct UFB *, void *, unsigned int) = NULL;
char _copyright[]           =   "QFAX 94";
char _prog_name[]           =   "printfax";
char _version[]             =    FAXVERS;

static long lit_reset (struct WM_wwork *, short); static long lit_event
(struct WM_wwork *, struct WM_litm *);

static long MMOVE (struct WM_wwork *, struct WM_litm *);
static long AHIT (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short);
static long AEXIT (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);

static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork               point back to work def */
    NULL,			/* *wdef                this was wdef */
    0,				/* chid                 chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos     sub-window and ptr posn */
    0, 0,			/* kstk, kprs           key stroke and press */
    0,				/* evnt                 event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare       window mode and spare */
    NULL,			/* *ciact               current item "action" */
    -1,				/* citem                current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0, 0, 0, 0, 0, 0, 0, 0}	/* litem[40]            loose item status */
};

#define ninfw    4		/* number of information windows */
#define ninfo    1		/* number of information objects */
#define nlitm    2		/* number of loose items */
#define nappl    2		/* number of application sub-windows */

#define winX     360
#define winY     50

static QD_TEXTI (END, "ESC");
static QD_TEXTI (TITLE, "QFAX-printfax");

static int   mpid = 0;
                        
static struct WM_info info[ninfo + 1] =
{
    {78, 10, 6, 0, 0, 0, 2, 0, 0, &TITLE},
    {-1}
};

static struct WM_infw infw[ninfw + 1] =		/* information window */
{
    {winX, 14,			/* xsize, ysize         size */
     0, 0,			/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 7, 84,  		/* borw, borc, papr     border width/clr,paper */
     NULL},			/* *pobj                pointer to object list */
    {90, 10,			/* xsize, ysize         size */
     (winX-90)/2+4, 2,		/* xorg, yorg           and origin */
     0,				/* flag                 no clear + shadow */
     0, 0, 7,			/* borw, borc, papr     border width/clr,paper */
     info},			/* *pobj                pointer to object list */
     {22,10,2,2,0,0,0,7,NULL},
     {22,10, winX-24,2, 0, 0, 0, 7, NULL},
    {-1}			/* end of array */
};

extern struct WM_sprite wm_sprite_move;

static struct WM_litm litm[nlitm + 1] =		/* loose item */
{
    {22, 10,   2, 2, 0, 0, 2, K_MOVE,   &wm_sprite_move,    0, &mmove},
    {22, 10, winX-24, 2, 0, 0, 0, K_CANCEL, &END,           1, &aexit},
    {-1}
};

static struct WM_appw aw0 =	/* application sub-window */
{
    winX, 40,			/* xsize, ysize         size */
    0, 14,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    0, 0, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL
};

static struct WM_appw aw1 =	/* application sub-window */
{
    winX, 10,			/* xsize, ysize         size */
    0, (40+14),			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    0, 0, 0,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    NULL,			/* *ctrl                control routine */
    0, 0,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL,			/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    CL_WRROW, CL_WBARB, CL_WBARS,	/* psac, psbc, pssc arrow/bar clrs */
    NULL
};

static struct WM_appl appl[nappl + 1] =
{
    &aw0, &aw1, NULL
};


static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat;              pointer to status area */
    NULL,			/* *wscale              this was pointer to WDEF */
    0,				/* chid                 channel ID */
    NULL,			/* *pprec               pointer to pointer record */
    0,				/* psave                pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst               pointer to sprite list */
    winX, winY+14,		/* xsize, ysize         size */
    0, 0,			/* xorg, yorg           and origin */
    2+NO_WCLEAR,		/* flag                 no clear + shadow */
    1, 4, 7,    		/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *sprite              pointer to sprite */
    1, 0,			/* curw, curc           current item width/clr */
    3, 7, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm        loose items */
    1, appl			/* nappl  *pappl        appl winds */
};


static chanid_t chid1, chid2;
static short xflg = 0, tflg = 0;
static short scol = 174;
static short clrme = 1;
static short nc, lc;

extern jcall (void (*)( ), char *, int, int, int,...);

static long lit_reset (struct WM_wwork *wwk, short lit)
{
    wwk->wstat->litem[lit] = WSI_MKAV;
    return wm_ldraw (wwk, -1);
}

static long lit_event (struct WM_wwork *wwk, struct WM_litm *li)
{
    return li->skey + 14;
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    mt_frjob(mpid, 0);
    exit (0);
}

static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw,
		  struct WM_wstat *wst, short x, short y, short evnt)
{
    tflg++;
    if(wst->evnt & PT_KYPRS || wst->evnt & PT_KYSTK || wst->evnt & PT_KEYUP)
    {
        xflg = 1;
    }
    return 50;
}


static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{
    int chid;

    chid = *((chanid_t *)apw->pstat);

    wm_swdef (wwk, apw, chid);
    return 0;
}

static long MMOVE (struct WM_wwork *wwk, struct WM_litm *li)
{
    short dx, dy;
    struct QLRECT rct1, rct2;

    if(mpid)
    {
        mt_susjb(mpid, -1, NULL);
    }
    sd_pxenq (chid1, -1, &rct1);
    sd_pxenq (chid2, -1, &rct2);
    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */

    ADRAW(wwk, &aw0);
    ADRAW(wwk, &aw1);

    sd_pixp (chid1, -1, rct1.q_x, rct1.q_y);
    sd_pixp (chid2, -1, rct2.q_x, rct2.q_y);

    if(mpid)
    {
        mt_reljb(mpid);
    }

    return lit_reset (wwk, li->item);
}

void PTRWindow(void)
{
    while(1)
    {
	wm_rptr (&ww);
    }
}

void ShowHelp (void)
{
    if (pv->interact & 1)
    {
        static char *h[] = {
            {"printfax  -o device [-t type]  [-c N] [-s N] files\n"},
            {"                    0 = HP (default)\n"},
	    {"                    1 = Epson 24 pin\n"},
	    {"                    2 = Epson  9 pin\n"}
        };
        io_sstrg(chid1, -1, h[0], strlen(h[0]));
        io_sstrg(chid1, -1, h[1], strlen(h[1]));
        io_sstrg(chid1, -1, h[2], strlen(h[2]));
        io_sstrg(chid1, -1, h[3], strlen(h[3]));
    }
}
void Report (char *ctl,...)
{
    static short ntop = 0;
    if (pv->interact & 1)
    {
	va_list va;
        char txt[128];
	va_start (va, ctl);
	vsprintf (txt, ctl, va);
	va_end (va);
        *(txt+59)=0;
        if(ntop)
        {
	    io_sbyte (chid1, 0, '\n');
	}            
        io_sstrg(chid1, 0, txt, strlen(txt));
        ntop = 1;
    }
}

void Warning (char *ctl,...)
{
    if (pv->interact & 1)
    {
	va_list va;
        char txt[128];
	va_start (va, ctl);
	vsprintf (txt, ctl, va);
	va_end (va);
        Report(txt);
    }
}

void ShowSize (void)
{
    if (pv->interact & 1)
    {
	nc = lc = 0;
        if(sd_pos (chid2, 0, 0, 0) == 0)
        {
            clrme = sd_clear(chid2, 0);
        }
        else
        {
            clrme = 1;
	}
    }
}

void ShowPlace (int at)
{
    static struct QLRECT rct = {0};
    
    if (pv->interact & 1)
    {
        short i;
        if(clrme)
        {
            ShowSize();
	}
        nc = at * 60 / pv->xline;
        if (nc <= 60 && lc < nc)
	{
            for (i = lc; i < nc && io_sbyte (chid2, 0, ' ') == 0; i++)
	    {
	        lc++;
	    }
        }
    }
}

void InitWindow(short noptr, short mono)
{
    short i;
    if(pv->interact & 1)
    {
        ww.chid = getchid (1);
        if ((noptr == 0) && wm_findv (ww.chid))
        {
            chid1 = = io_open("scr", 0);
            aw0.pstat = (char *) &chid1;
            chid2 = io_open("scr", 0);
            aw1.pstat = (char *) &chid2;
            mpid = getpid();
            ws.wwork = &ww;		/* set cross reference */
            if(mono)
            {
                info[0].attr.t.ink = 0;
                infw[0].papr = 127;
                ww.borc = 7;
                sd_setin(chid1, -1, 7);
            }
            wm_prpos (&ww, -1, -1);
            wm_wdraw (&ww);
            jcall(PTRWindow, "prtfax-Ptr", 1, 2048, 0);
            mt_prior(-1, 10);
        }
        else
        {
            static struct QLRECT rct;

            rct = *((struct QLRECT *) &_condetails.width);

            chid1 = getchid(1);
            chid2 = io_open("scr", 0);
            consetup_title(chid1, &_condetails);

            rct.q_width -= 4;
            rct.q_x += 2;
            rct.q_y += 14;
            rct.q_height = 40;
            sd_wdef(chid1, -1, 0, 0, &rct);
            rct.q_height = 10;
            rct.q_y += 40;
            sd_wdef(chid2, -1, 0, 0, &rct);
        }   
        sd_setin(chid2, -1, scol); 
        sd_setst(chid2, -1, scol); 
        pv->interact &= ~2;
    }
}
void MyExit(short wait, int n)
{
    static const char p[] = " ; Press a key to exit";    

    extern char * _endmsg;
    _endmsg = NULL;

    if(wait)
    {
        if(mpid)
        {
            short tcnt;
            io_sstrg(chid1, 0, p, sizeof(p)-1);
            xflg = 0;
            for (tcnt = 0; (xflg == 0) && ((tcnt < 10)); tcnt++)
            {
                sleep(1);
            }
        }
    }
    exit(n);        
}
/***
#ifdef TEST
static VIEWPORT vp = {0,};
PVIEWPORT pv = &vp;
main(int ac, char **av)
{
    int i = 0;

    pv->interact = 1;
    InitWindow(ac-1, 0);
    Report("starting ...");
    sleep(4);
    Report("starting .1.");
    sleep(4);
    Report("starting .2.");
    sleep(4);
    Report("starting .3.");
    sleep(4);
    Report("starting .4.");
    sleep(4);
    Report("starting .5.");

    ShowSize();
    pv->xline = 60;
    for(i = 0; i < 60;i++)
    {
        mt_susjb(-1, 12, NULL);
        ShowPlace(i);
    }    
    MyExit(1, 0);
}
#endif
***/
