#include <lib/rexx.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <dos/dos.h>

#include "qfax.h"

char *RexxHostName = NULL;

static rflag = 0;

void StartRexx(void)
{
    short r = -1;
    
    if(RexxSysBase)
    {
        r = CreateGlobalDiceRexxPort(NULL, QFAX_REXX);
    }
    if(r < 0)
    {
        _exit(20);
    }
}


int CheckRexx(void)
{
    int rflag = 0;
    if(CheckSignal((1 << RexxSigBit)))
    {
        ProcessRexxCommands(NULL);
        while(rflag == 2)
        {
            long mask = Wait(SIGBREAKF_CTRL_C | (1 << RexxSigBit));
            if(mask & SIGBREAKF_CTRL_C)
            {
                rflag = 1;
            }
            else
            {
                ProcessRexxCommands(NULL);
            }
        }
    }
    return (rflag);
}

typedef struct
{
    char *cmd;
    void (*func)(void);
} RLIST;
#if 0
static void rexxsuspend (void)
{
    msg(-1,"ZVoice is suspended");
    rflag = 2;
}

static void rexxwake (void)
{
    rflag = 4;
    msg(-1,"ZVoice is available");
}
#endif
static void rexxexit (void)
{
    rflag = 1;
}

long DoRexxCommand(void *msg, struct MsgPort *port, char *arg0, char ** pres)
{
    static RLIST rcl[] =
    {
#if 0
        {"suspend", rexxsuspend },
        {"wake",    rexxwake},
#endif
        {"exit",    rexxexit },
        {"quit",    rexxexit },
        {NULL, NULL }
    };
    RLIST *prc;
    int rc = 5;

    for(prc = rcl; prc->cmd; prc++)
    {
        if(strncasecmp(arg0, prc->cmd, strlen(prc->cmd)) == 0)
        {
            (*prc->func)();
            rc = 0;
            break;
        }
    }
    return rc;
}
