#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <stdarg.h>
#include <time.h>

#include <fcntl.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifdef QDOS
# include <Qdos.h>
# define Delay(p1)       mt_susjb(-1, p1,NULL)
#else
# include <getopt.h>
  extern void Delay (int);
#endif

#include "/lib/qheader.h"
#include "/lib/QFaxParse.h"
#include "qfax.h"

FAXDATA qd = {0,};

short msg (short err, char *s,...)
{
    va_list ap;
    time_t et;
    char *t, txt[132];
    struct tm *p;

    et = time (NULL);
    p = localtime (&et);

    va_start (ap, s);

    sprintf (txt, "%02d:%02d:%02d ", p->tm_hour, p->tm_min, p->tm_sec);
    t = txt + strlen (txt);
    vsprintf (t, s, ap);
    va_end (ap);

    puts (txt);
    return err;
}


short readser(char * buf)
{
    char *p = buf;
    char c;    
    short err = 0;
    
    *p = 0;
    while(1)
    {
        if(SRead(&c, 1, 5) == 1)
        {
            if(c < 32)
            {
                if(c == 13)
                {
                    *p = 0;
                    break;
                }
            }
            else
            { 
                *p++ = c;
            }
	}
        else
        {
            err = 1;
            break;
        }
    }
    if(*buf)
    {
        msg(0, buf);
    }
    return err;
}

int main (int ac, char **av)
{
    FILE *fp;
    char *p, buf[128];
    
    FaxParams (&qd);

    tty_open (1);

    if(fp = fopen(av[1], "r"))
    {
        while(fgets(buf, 128, fp))
        {
            if(p = strchr(buf, '\n'))
            {
                *p = '\r';
                SWrite(buf, -1);
                while(!readser(buf) && (*buf == 0 || *buf == 'A'))
                    ; /* loop */
                Delay(2);
            }
        }
    }
    fclose(fp);
    tty_close();
}
