#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <time.h>

#include <things.h>
#include <qptr.h>
#include "qfv.h"

typedef struct mitem
{
    short len;
    char chrs[1];
}
MITEM, *PMITEM;

typedef struct
{
    char path[40];
    time_t stamp;
} FAXITEM;

typedef struct
{
    int flag;
    int type;
    short maxitems;
    short current;
    short nitems;
    FAXITEM fdata[1];
} FAX_LIST;

/*
 * Let's just have one of these
 */

static char *Stuff = "QFAX Items";

#define STUFF_SIZE 10

#if 0
char *qtrim (char *ep)
{
    char *p;
    short i;
    
    p = ep + strlen(ep);
    for(i = 0; i < 3 && --p > ep;)
    {
        if(*(p-1) == '_')
        {
            i++;
        }
    }
    return p;
}
#endif


static ins_list (PLLIST * pHead, PLLIST pi)
{
    PLLIST pz;

    if ((pz = *pHead) == NULL)
    {
	pi->next = NULL;
    }
    else
    {
        pi->next = pz;
    }
    *pHead = pi;
}
rem_node (PLLIST * pHead, int n)
{
    int i;
    PLLIST pi, pz, pl;

    if (*pHead)
    {
	pl = NULL;
	for (pz = *pHead, i = 0; i < n; i++)
	{
	    pl = pz;
	    pz = pz->next;
	}
	if (pl)
	{
	    pl->next = pz->next;
	}
	else
	{
	    *pHead = pz->next;
	}
	free (pz->item);
	free (pz);
    }
}

static AddFaxMenu (PLLIST * pX, char *q)
{
    PMITEM s;
    PMDEF pm;
    PLLIST pl;
    short n;

    n = strlen(q) + 8;

    s = (PMITEM) malloc (n);
    strcpy (s->chrs, q);
    s->len = strlen (s->chrs);
    pm = (PMDEF) malloc (sizeof (MDEF));
    pm->qtext = (struct QD_text *) s;
    pm->status = WSI_AVBL;
    pm->retval = 0;
    pm->action = NULL,
    pm->skey = 0;
    pm->skey = (*s->chrs == ' ') ? 0 : -1;
    pl = (PLLIST) malloc (sizeof (LLIST));
    pl->item = pm;
    pl->next = NULL;
    ins_list (pX, pl);
}

/*
 * Returns -1  for error
 *          0  for no items
 *         +ve items in list
 */
 
static char * AddElement(char *qt, short elem, char sep)
{
    *qt++ = '0'+ (elem / 10);
    *qt++ = '0'+ (elem % 10);
    *qt++ = sep;
    return qt;    
}

int BuildFaxMenu (PLLIST * pX)
{
    int n = -1;
    THING_LINKAGE *p = NULL;
    long vers = 0;
    void *q;
    int sts;
    
    sts = (int) sms_uthg (Stuff, -1, -1, NULL, NULL, &vers, &p);
    if (sts > 0)
    {
	char txt[64];
	short i, j, k, m, flen = 0;

        FAX_LIST *f = (FAX_LIST *)sts;
       
	if (n = f->nitems)
        {	
            j = f->current;
	    for (i = 0; i < n; i++, j++)
            {
                j = j % n;
                if((k = strlen(f->fdata[j].path)) > flen)
                {
                    flen = k;
                }
            }

            j = f->current;
	    for (i = 0; i < n; i++, j++)
	    {
                time_t t1;
                char *s, *fillc;
		char c, ttxt[32];
                struct tm *tm;
                s = txt;

                j = j % n;
                t1 = TIME_QL_UNIX(f->fdata[j].stamp);
                tm = localtime(&t1);
                m = n - i- 1;
    	        if (m < 10)
	        {
		    c = m + 48;
	        }
	        else if (m > 9 && m < 36)
	        {
		    c = m + 55;
	        }
	        else
	        {
		    c = ' ';
	        }

                *s++ = c;
                *s++ = ' ';
                strcpy(s, f->fdata[j].path);
                s += strlen(s);
                fillc = txt + (3 + flen);
                while(s < fillc)
                {
                    *s++ = ' ';
                }

                s = AddElement(s, tm->tm_mday,'/');
                s = AddElement(s, (tm->tm_mon+1),'/');
                s = AddElement(s, tm->tm_year % 100,' ');
                s = AddElement(s, tm->tm_hour,':');
                s = AddElement(s, tm->tm_min,':');
                s = AddElement(s, tm->tm_sec,'\0');
		AddFaxMenu (pX, txt);
	    }
	}
	sts = sms_fthg (Stuff, -1, NULL, 0, NULL, NULL);
    }
    return n;
}
#if 0
int BuildFaxMenu (PLLIST * pX)
{
    int n = -1;
    PTHG_LINK p = NULL;
    int vers = 0;
    void *q;
    int sts;
    
    sts = sms_uthg (Stuff, -1, -1, NULL, &p, &vers, &q);
    if (sts == 0)
    {
	char txt[64];
	short i, j, k, m, flen = 0;
        FAX_LIST *f = (FAX_LIST *)p->thing;
       
	if (n = f->nitems)
        {	
            j = f->current;
	    for (i = 0; i < n; i++, j++)
            {
                j = j % n;
                if((k = strlen(f->fdata[j].path)) > flen)
                {
                    flen = k;
                }
            }

            j = f->current;
	    for (i = 0; i < n; i++, j++)
	    {
                
		char c, ttxt[32];
                struct tm *tm;

                j = j % n;
                t1 = TIME_QL_UNIX(f->fdata[j].stamp);
                tm = localtime(&t1);

                sprintf(ttxt, "%02d/%02d/%02d %02d:%02d:%02d",
                    tm->tm_mday, tm->tm_mon, tm->tm_year % 100,
                    tm->tm_hour, tm->tm_min, tm->tm_sec);
                    
                m = n - i- 1;
    	        if (m < 10)
	        {
		    c = m + 48;
	        }
	        else if (m > 9 && m < 36)
	        {
		    c = m + 55;
	        }
	        else
	        {
		    c = ' ';
	        }

		sprintf (txt, "%c %-*.*s %s", c, flen, flen, f->fdata[j].path, ttxt);
		AddFaxMenu (pX, txt);
	    }
	}
	sts = sms_fthg (Stuff, -1, 0, NULL, NULL, NULL);
    }
    return n;
}
#endif
FreeFaxList (PLLIST *pL)
{
    PLLIST p;

    for (p = *pL; p;)
    {
	PMITEM s;
	PMDEF pm;
	PLLIST pd;

	pd = p;
	p = p->next;
	pm = (PMDEF) pd->item;
	s = (PMITEM) pm->qtext;
	free (s);
	free (pm);
	free (pd);
    }
    *pL = NULL;
}

int DoFaxMenu(struct WM_wwork *wwk, PLLIST *pL, int nmnu,
        struct WM_litm * plitm, int nlitm, short wid)
{
    int n;
    short tlen;
    
   
    n = menu(wwk, "QFAX NT", pL, nmnu, 50, 50, 0, 0, plitm, nlitm);

    if(n >= 0)
    {
        short i;
        PLLIST p;
        for (p = *pL, i = 0; i < n; p = p->next,i++)
            ;
            
        {
    	    PMITEM s;
	    PMDEF pm;
            char *q;
            
 	    pm = (PMDEF) p->item;
	    s = (PMITEM) pm->qtext;
	    strcpy(pv->FileName, s->chrs+2);
            if(q = strchr(pv->FileName, ' '))
            {
                *q = '\0';
            }
        }
    }
    return n;
}
