#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <qdos.h>
#include <qptr.h>
#include <stdarg.h>
#include <time.h>
#include <memory.h>
#include <fcntl.h>
#include <unistd.h>

#include <sys/stat.h>

#include "qfv.h"

void (*_SigStart)(void) = NULL;

static long ACTRL (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short bpos, short blen, short, short);
static long AHIT (struct WM_wwork *, struct WM_appw *, struct WM_wstat *, short, short, short);
static long AEXIT (struct WM_wwork *, struct WM_litm *);
static long ADRAW (struct WM_wwork *, struct WM_appw *);
static long MMOVE (struct WM_wwork *);
static long AICON (struct WM_wwork *, struct WM_litm *);
static long MEDIT (struct WM_wwork *, struct WM_litm *);
static long MBARS (struct WM_wwork *, struct WM_litm *);
static long ASLEEP (struct WM_wwork *, struct WM_litm *);
static long MARRAS (struct WM_wwork *, struct WM_litm *);

static struct WM_action mbars = {JSR, wm_actli, MBARS};
static struct WM_action marras = {JSR, wm_actli, MARRAS};
static struct WM_action medit = {JSR, wm_actli, MEDIT};
static struct WM_action afun = {JSR, wm_actli, lit_event};
static struct WM_action asleep = {JSR, wm_actli, ASLEEP};
static struct WM_action aicon = {JSR, wm_actli, AICON};
static struct WM_action aexit = {JSR, wm_actli, AEXIT};
static struct WM_action adraw = {JSR, wm_drwaw, ADRAW};
static struct WM_action ahit = {JSR, wm_hitaw, AHIT};
static struct WM_action mmove = {JSR, wm_actli, MMOVE};
static struct WM_action actrl = {JSR, wm_ctlaw, ACTRL};

static WM_PWCB (1) xcb ={0};
static WM_PWCB (1) ycb ={0};

static struct WM_wstat ws =	/* window status area */
{
    NULL,			/* *wwork               point back to work def */
    NULL,			/* *wdef                this was wdef */
    0,				/* chid                 chan ID enclosing pointer */
    0, 0, 0,			/* swnr, xpos, ypos     sub-window and ptr posn */
    0, 0,			/* kstk, kprs           key stroke and press */
    0,				/* evnt                 event vector */
    0, 0, 0, 0,			/* xsiz, ysiz, xorg, yorg  */
    0, 0,			/* ptpsx, ptpsy         pointer position (abs) */
    FORM_QL4, 0, 0,		/* wmode, 2 spare       window mode and spare */
    NULL,			/* *ciact               current item "action" */
    -1,				/* citem                current item */
    0, 0, 0,			/* cibrw, cipap, cispr  current item attr */
    0, 0, 0, 0,			/* cihxs,ys, cihxo,yo   current item hit area */
    {0}				/* litem[40]            loose item status */
};

#define ninfw    14		/* number of information windows */
#define ninfo    2		/* number of information objects */
#define nlitm    11		/* number of loose items */
#define nappl    1		/* number of application sub-windows */

static QD_TEXTI (END, "ESC");
static QD_TEXTI (VIEW, "qfv");
static QD_TEXTI (MENU, "Menu");
static QD_TEXTI (MAGS, "Mag.");
static QD_TEXTI (MTEXT, "0");
static QD_TEXTI (LARR, "<");
static QD_TEXTI (RARR, ">");

static struct WM_info info1[2] =
{
    {66, 10, 6, 0, 0, 0, 0, 0, 0, &VIEW},
    {-1}
};
static struct WM_info info2[2] =
{
    {26, 10, 1, 0, 0, 0, 0, 0, 0, &MAGS},
    {-1}
};

static struct WM_infw infw[ninfw + 1] =		/* information window */
{
    {446, 14,			/* 0 xsize, ysize      size */
     0, 0,			/* xorg, yorg        and origin */
     0,				/* flag              no clear + shadow */
     0, 1, 121,			/* borw, borc, papr  border width/clr,paper */
     NULL},			/* *pobj             pointer to object list */
    {30, 10,			/* 1 xsize, ysize      size */
     228, 2,			/* xorg, yorg        and origin */
     0,				/* flag              no clear + shadow */
     1, 255, 7,			/* borw, borc, papr  border width/clr,paper */
     info1},			/* *pobj             pointer to object list */
    {442, 14,			/* 2 xsize, ysize      size */
     2, 15,			/* xorg, yorg        and origin */
     0,				/* flag              no clear + shadow */
     1, 255, 7,			/* borw, borc, papr  border width/clr,paper */
     NULL},
    {26, 10,			/* 3 xsize, ysize      size */
     6, 17,			/* xorg, yorg        and origin */
     0,				/* flag              no clear + shadow */
     1, 255, 7,			/* borw, borc, papr  border width/clr,paper */
     NULL},			/* *pobj             pointer to object list */
    {350, 10,			/* 4 xsize, ysize      size */
     40, 17,			/* xorg, yorg        and origin */
     0,				/* flag              no clear + shadow */
     1, 255, 7,			/* borw, borc, papr  border width/clr,paper */
     NULL},			/* *pobj             pointer to object list */
    {26, 10,			/* 5 xsize, ysize      size */
     398, 17,			/* xorg, yorg        and origin */
     0,				/* flag              no clear + shadow */
     1, 255, 7,			/* borw, borc, papr  border width/clr,paper */
     info2},			/* *pobj             pointer to object list */
    {6, 10,			/* 6 xsize, ysize      size */
     428, 17,			/* xorg, yorg        and origin */
     0,				/* flag              no clear + shadow */
     1, 255, 7,			/* borw, borc, papr  border width/clr,paper */
     NULL},			/* *pobj             pointer to object list */
    {22, 10, 4, 2, 0, 1, 255, 7, NULL},
    {22, 10, 34, 2, 0, 1, 255, 7, NULL},
    {22, 10, 64, 2, 0, 1, 255, 7, NULL},
    {22, 10, 94, 2, 0, 1, 255, 7, NULL},
    {22, 10, 410, 2, 0, 1, 255, 7, NULL},
    { 8, 10, 210, 2, 0, 1, 255, 7, NULL},
    { 8, 10, 268, 2, 0, 1, 255, 7, NULL},
    {-1}			/* end of array */
};

extern struct WM_sprite mes_move, mes_size, mes_wake, wm_sprite_sleep,
 mes_null;

#define LI_MOVE   0
#define LI_SIZE   1
#define LI_WAKE   2
#define LI_SLEEP  3
#define LI_EXIT   4
#define LI_MENU   5
#define LI_MAGIT  6
#define LI_BARSHT 7
#define LI_BARTAB 8
#define LI_PREV   9
#define LI_NEXT   10

static struct WM_litm litm[nlitm + 1] =		/* loose item */
{
    {22, 10, 4, 2, 0, 0, 2, K_MOVE, &mes_move, LI_MOVE, &mmove},
    {22, 10, 34, 2, 0, 0, 2, K_SIZE, &mes_size, LI_SIZE, &afun},
    {22, 10, 64, 2, 0, 0, 2, K_WAKE, &mes_wake, LI_WAKE, &afun},
    {22, 10, 94, 2, 0, 0, 2, K_SLEEP, &wm_sprite_sleep, LI_SLEEP, &asleep},
    {22, 10, 410, 2, 0, 0, 0, K_CANCEL, &END, LI_EXIT, &aexit},
    {26, 10, 6, 17, 0, 0, 0, 0xf0, &MENU, LI_MENU, &aicon},	/* F3 */
    {6, 10, 428, 17, 0, 0, 0, 'M', &MTEXT, LI_MAGIT, &medit},
    {2, 2, 2, 1, 0, 0, 2, 0xfd, &mes_null, LI_BARSHT, &mbars},
    {2, 2, 2, 1, 0, 0, 2, K_TAB, &mes_null, LI_BARTAB, &mbars},
    {8, 10, 210, 2, 0, 0, 0, '<', &LARR, LI_PREV, &marras},
    {8, 10, 268, 2, 0, 0, 0, '>', &RARR, LI_NEXT, &marras},
    {-1}
};

static struct WM_menw aw0 =	/* application sub-window */
{
    442, 198,			/* xsize, ysize         size */
    2, 31,			/* xorg, yorg           and origin */
    0,				/* flag                 no clear + shadow */
    1, 255, 7,			/* borw, borc, papr     border width/clr, paper */
    NULL,			/* *pspr                pointer to sprite */
    &adraw,			/* *draw                draw routine */
    &ahit,			/* *hit                 hit routine */
    &actrl,			/* *ctrl                control routine */
    1, 1,			/* nxsc, nysc           max x,y sections */
    0, 0, 0,			/* skey, 2 spare        selection keystroke */
    (WM_pwcb_t *) & xcb,	/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    4, 4, 0,			/* psac, psbc, pssc arrow/bar clrs */
    (WM_pwcb_t *) & ycb,	/* *pwcb            part window ctrl block */
    0, 0, 0, 0, 0, 0, NULL, NULL,	/* 6 short 2 pointer zero */
    4, 4, 0,			/* psac, psbc, pssc arrow/bar clrs */
    {0}
};

static struct WM_appl appl[nappl + 1] = {(WM_appw_t *) & aw0, NULL};

static WM_WSCALE (ninfw + ninfo + nlitm + nappl) wsc =
{
    278, 136, 0, 0, 8, 12,	/* was 278 */
     {
	{8, 0, 0, 0},		/* infw[0], x scale */
	{0, 0, 4, 0},		/* infw[1], centre */
	{0, 0, 0, 0},		/* info[0], no scale */
	{8, 0, 0, 0},		/* infw[2], x scale */
	{0, 0, 0, 0},		/* infw[3], x scale */
	{8, 0, 0, 0},		/* infw[4], x scale */
	{0, 0, 8, 0},		/* infw[5], Right */
	{0, 0, 0, 0},		/* info[0], no scale */
	{0, 0, 8, 0},		/* infw[6], Right */
	{0, 0, 0, 0},		/* infw[7], no scale */
	{0, 0, 0, 0},		/* infw[8], no scale */
	{0, 0, 0, 0},		/* infw[9], no scale */
	{0, 0, 0, 0},		/* infw[10], no scale */
	{0, 0, 8, 0},		/* infw[11], right jst */
	{0, 0, 4, 0},		/* infw[12], no scale */
	{0, 0, 4, 0},		/* infw[13],          */
	{0, 0, 0, 0},		/* litm[0], no scale */
	{0, 0, 0, 0},		/* litm[1], no scale */
	{0, 0, 0, 0},		/* litm[2], no scale */
	{0, 0, 0, 0},		/* litm[3], no scale */
	{0, 0, 8, 0},		/* litm[4], right jst */
	{0, 0, 0, 0},		/* litm[5], left jst */
	{0, 0, 8, 0},		/* litm[6], right jst */
	{0, 0, 0, 0},		/* litm[7], no scale */
	{0, 0, 0, 0},		/* litm[8], no scale */
	{0, 0, 4, 0},		/* litm[9], no scale */
	{0, 0, 4, 0},		/* litm[10], no scale */
	{8, 8, 0, 0}	        /* appl[0], full scale */
    }
};

static struct WM_wwork ww =	/* window working definition */
{
    &ws,			/* *wstat pointer to status area */
    (WM_wscale_t *) & wsc,	/* *wscale this was pointer to WDEF */
    0,				/* chid channel ID */
    NULL,			/* *pprec pointer to pointer record */
    0,				/* psave pointer position saved */
    0, 0, 0, 0,			/* 4 zero */
    appl,			/* *splst pointer to sprite list */
    446, 232,			/* xsize, ysize size */
    20, 20,			/* xorg, yorg and origin */
    NO_WCLEAR | 0x2,		/* flag no clear + shadow */
    0, 7, 255,			/* borw, borc, papr border width/clr, paper */
    NULL,			/* *sprite pointer to sprite */
    1, 0,			/* curw, curc current item width/clr */
    7, 2, NULL, NULL,		/* uback, uink, *ublob, *upatt  unavail */
    7, 0, NULL, NULL,		/* aback, aink, *ablob, *apatt  avail */
    7, 0, NULL, NULL,		/* sback, sink, *sblob, *spatt  selected */
    NULL,			/* *help */
    ninfw, ninfo, infw,		/* ninfo, ninob, *pinfo info winds */
    nlitm, litm,		/* nlitm, *plitm        loose items */
    nappl, appl			/* nappl  *pappl        appl winds */
};

long (*_cmdchannels) (long) = NULL;
long (*_stackchannels) (long) = NULL;
void (*_consetup) (chanid_t, struct WINDOWDEF *) = NULL;
int (*_conread) (struct UFB *,void *,unsigned int) = NULL;
int (*_conwrite) (struct UFB *,void *,unsigned int) = NULL;
char *_endmsg = NULL;

#ifndef FAXVERS
#define FAXVERS "Missing"
#endif

long _stack = 11000;

struct WM_wwork *QFVww = &ww;	/* Global ref */

static VIEWPORT vp = {0};
PVIEWPORT pv = &vp;
FAXDATA qd = {0};

char _prog_name[] = "qfv";
char _version[] = FAXVERS;

extern setptr (int, int, short *, short *, int);
extern short ScrollIt (short);
extern short PanIt (short);
extern jcall (void (*)(), char *, int, int, int,...);
extern struct WM_wsiz *GetLimits (struct WM_wwork *);
extern int PrintPage (int, char *);
extern void ClosePrt (int);
extern int exists (char *);
extern void IniPrt(FAXDATA *);
extern int Check4Scan (int);
extern void ScanFaxFile(void);

static char *ssaved = NULL;
char range [256] = {0};

#define MM_BASIC (M_LOAD | M_SETUP)

static short fact = MM_BASIC;
static short saveflag = 1;

static short lx = 0, ly = 0;
static short tf_opt = 0;

static time_t lastTime = 0;
static short skipbad = 1, badlines = 0;
static short warn = 0;

static FILE *fpQ = NULL;
static short zflag = 0, bflag = 0;
static int zjob = 0;
static int memlimit = 0x7fffffff;
static ScanReq = 0;

#define MIN_MEM 120000

short toskip = 0;
short skipall = 0;
extern short mineop;

extern void WaitButton ();

int CheckLastFile (void)
{
    char qnam[80];

    sprintf (qnam, "%sQFAX-LastFax", qd.in_dir);
    return exists (qnam);
}
time_t GetLastFile (void)
{
    FILE *fp;
    char *p, qnam[80];
    int rv = 0;

    sprintf (qnam, "%sQFAX-LastFax", qd.in_dir);
    if (fp = fopen (qnam, "r"))
    {
	struct stat s;

	fstat (fileno (fp), &s);
	if (p = strchr (fgets (pv->FileName, sizeof (pv->FileName), fp), '\n'))
	{
	    *p = 0;
	    rv = s.st_ctime;
	}
	fclose (fp);
    }
    return rv;
}

static short CheckFile (void)
{
    short can_do = 0;

    if (pv->FaxPage > 0)
    {
	can_do |= M_PPREV;
	ws.litem[LI_PREV] = WSI_MKAV;
    }
    else ws.litem[LI_PREV] = WSI_MKUN;

    if (pv->FaxPage <  pv->qh.pagemax - 1)
    {
	can_do |= M_PNEXT;
	ws.litem[LI_NEXT] = WSI_MKAV;
    }
    else ws.litem[LI_NEXT] = WSI_MKUN;

    if(pv->qh.pagemax > 1)
    {
	can_do |= M_GOTO;
    }

    wm_ldraw(&ww, -1);

    ws.litem[LI_NEXT] &= ~1;
    ws.litem[LI_PREV] &= ~1;    

    return can_do;
}
void Checkxstt (short pos)
{
    aw0.xpwcb->s[0].stt = pos;

    if (aw0.xpwcb->s[0].stt > aw0.ncol - aw0.xpwcb->s[0].siz)
    {
	aw0.xpwcb->s[0].stt = aw0.ncol - aw0.xpwcb->s[0].siz;
    }
    if (aw0.xpwcb->s[0].stt < 0)
    {
	aw0.xpwcb->s[0].stt = 0;
    }
}

void Checkystt (short pos)
{
    aw0.ypwcb->s[0].stt = pos;

    if (aw0.ypwcb->s[0].stt > aw0.nrow - aw0.ypwcb->s[0].siz)
    {
	aw0.ypwcb->s[0].stt = aw0.nrow - aw0.ypwcb->s[0].siz;
    }
    if (aw0.ypwcb->s[0].stt < 0)
    {
	aw0.ypwcb->s[0].stt = 0;
    }
}
static void ShowStatus (struct WM_wwork *wwk, short timo, char *ctl,...)
{
    short nlen;

    va_list va;
    char t[80];

    va_start (va, ctl);

    vsprintf (t, ctl, va);
    va_end (va);

    nlen = infw[4].xsize / 6;
    if (nlen >= 80)
    {
	nlen = 79;
    }
    t[nlen] = 0;
    wm_swinf (wwk, 4, 0);
    if(sd_clear (wwk->chid, timo) == 0)
	io_sstrg (wwk->chid, timo, t, (short) strlen (t));
}
void ShowMpg (struct WM_wwork *wwk)
{
    short mpg;

    mpg = (pv->qh.pagemax > 0) ? pv->qh.pagemax : 1;
    ShowStatus (wwk, -1, "%s ... %d/%d", pv->FileName, pv->FaxPage + 1, mpg);
}
void Warning (char *ctl,...)
{
    va_list va;
    char t[80];

    if (warn)
    {
	va_start (va, ctl);
	vsprintf (t, ctl, va);
	ShowStatus (&ww, -1, t);
	va_end (va);
    }
}
void Report (char *ctl,...)
{
    va_list va;
    char t[80];

    va_start (va, ctl);
    vsprintf (t, ctl, va);
    va_end (va);

    menu_choice (&ww, t, 1, 0, "OK");
}
#ifdef KPRINT
void kprint(char *txt,...)
{
    static FILE *kp = NULL;
    static char *eoln;
    
    if(kp == NULL)
    {
	char *s;
	if((s = getenv("DBGPRT")))
	{
	    if((kp = fopen(s, "w")))
	    {
	        if(strnicmp(s,"ser", 3) == 0)
	        {
		    eoln = "\n\r";
	        }
	        else
	        {
		    eoln = "\n";
	        }
	        fputs("Opened ", kp);
	        fputs (eoln, kp);
	    }
	}
    }

    if(kp)
    {
	va_list va;
	va_start (va, txt);
	vfprintf (kp, txt, va);
	va_end (va);
	fputs (eoln, kp);
	fflush(kp);
    }
}
#else
#define kprint(p1)
#endif

static void ResetAll (struct WM_wwork *wwk, short flag)
{
    if (ssaved == NULL)
    {
	pv->xsize = aw0.xsize;
	pv->ysize = aw0.ysize;

	ResetPage (flag);
	aw0.ypwcb->s[0].pos = 0;
	aw0.ypwcb->s[0].siz = (aw0.ysize * 4 * pv->fct) / 3;
	aw0.nrow = pv->xline;

	aw0.xpwcb->s[0].pos = 0;
	aw0.xpwcb->s[0].siz = aw0.xsize * pv->fct;
	aw0.ncol = pv->F_pix;

	Checkystt (pv->tos);
	Checkxstt (pv->offset * 8);
    }
    wm_index (wwk, (struct WM_swdef *) &aw0);
}

void Doze (short flag)
{
    int sts = -99;
    int nsave = -1;

    aw0.xsize = ww.xsize - AWXOFF;
    aw0.ysize = ww.ysize - AWYOFF;

    kprint ("Sleep step 1");

    if (flag && saveflag && fpQ)
    {
	nsave = 8 + (aw0.xsize + 3) / 4;
	nsave = nsave * aw0.ysize + 512;
	kprint (("Sleep step 2 (%d)", nsave));
	if ((ssaved = malloc (nsave)))
	{
	    kprint ("Sleep step 3");
	    if ((sts = iop_wsav (pv->chan, -1, ssaved, nsave)) != 0)
	    {
		kprint ("Sleep step 4");
		free (ssaved);
		ssaved = NULL;
	    }
	}
	else
	    kprint ("Sleep step 4a");
    }
    else
    {
	kprint ("Sleep step 5");
	ssaved = NULL;
    }
    kprint ("Sleep step 6");
    menu_button (&ww, "qfv", flag);
}

static int GuessMem (short *actual)
{
    int tmem;
    short lines;

    if (pv->qh.version > QFAXNEWFMT && pv->qh.hint)
    {
	lines = pv->qh.hint << (1 - pv->qh.resolution);
    }
    else
    {
	lines = pixhgt[pv->qh.page];
    }
    tmem = (SLACK + lines) * (pixwid[pv->qh.width] >> 3);
    *actual = lines;
    return tmem;
}

static short LoadFile (struct WM_wwork *wwk, short flag)
{
    short req = 0;
    int t1;
    int rv;
    short mlin;
    static int memalloc = 0;
    int reqmem;
    short mpg;
    int pid;
    int maxl;
    
    pid = getpid ();

    fact = 0;
    if (!lastTime)
    {
	lastTime = (time_t) CheckLastFile ();
    }

    if (flag)
    {
	fpQ = FindFax (2);
	if (fpQ)
	{
	    int fmem, tmem;

	    memset(range, 0, 256);
	    pv->F_pix = pixwid[pv->qh.width];
	    pv->F_char = pv->F_pix >> 3;
	    reqmem = GuessMem (&mlin);
	    if (pv->scan == NULL)
	    {
		fmem = mt_free () - 32 * 1024;
		if (fmem < MIN_MEM)
		{
		    Report ("Need more memory ... ");
		    exit (0);
		}
		tmem = (SLACK + pixhgt[pv->qh.page]) * pv->F_char;
		if (tmem > reqmem && tmem < fmem)
		{
		    memalloc = tmem;
		}
		else if (reqmem < fmem)
		{
		    memalloc = reqmem;
		}
		else
		{
		    memalloc = fmem;
		}
		if (memlimit < memalloc)
		{
		    memalloc = memlimit;
		}
		pv->scan = malloc (memalloc);
		pv->maxmem = memalloc;
	    }

	    if (pv->scan && reqmem > memalloc)
	    {
		Report ("Banding (%d b)",
			reqmem - memalloc);
		mlin = (memalloc / pv->F_char) - SLACK;
	    }
	    pv->F_page = mlin;
	    pv->buck = mlin;

	    ScanReq = pv->FaxPage;
	}
    }

    if (fpQ)
    {
	if(ScanReq)
	{
	    if(pv->FaxPage >= pv->qh.pagemax)
	    {
		pv->FaxPage = pv->qh.pagemax - 1;
	    }
	    
	    if(Check4Scan(pv->FaxPage) == 0)
	    {
		ShowStatus (wwk, -1, "Scanning fax file %s", pv->FileName);
		ScanFaxFile();
	    }
	    ScanReq = 0;
	}
	mpg = (pv->qh.pagemax > 0) ? pv->qh.pagemax : 1;
	ShowStatus (wwk, -1, "Loading %s ... %d/%d",
		    pv->FileName, pv->FaxPage + 1, mpg);
	t1 = time (NULL);
	bzero (pv->scan, memalloc);

	if (zflag)
	{
	    Doze (0);
	    zjob = jcall (WaitButton, "qfv Zzz", 1, 1024, 1, 0);
	}
#ifdef FUBAR
	Report ("enter decoder with page %d", pv->F_page);
#endif
	rv = decode_fax2 (&maxl, pv->FaxPage, skipbad, &badlines);
	if (zflag)
	{
	    extern int pick (int, int, int, int);
	    short x = 20, y = 20;

	    if (zjob)
	    {
		mt_frjob (zjob, 0);
	    }

	    bflag = 1;
	    pick (pv->chan, -1, pid, K_WAKE);
	    debutton (wwk);
	    bflag = 0;
	    setptr (wwk->chid, -1, &x, &y, -1);
	}

	if (rv == 0)
	{
	    pv->eon = time (NULL) - t1;
	    if (zflag)
	    {
		req = 0;
	    }
	    else
	    {
		req = 3;
	    }
	    fact |= (MM_BASIC | M_PRINT | M_INFO | M_FLIP);
	    fact |= CheckFile ();
	}
    }

    if (fpQ == NULL || rv != 0)
    {
	pv->xline = pv->eon = 0;
	fact = MM_BASIC;
	ShowStatus (wwk, -1, "Load failed for %s", pv->FileName);
	*pv->FileName = 0;
    }
    else
    {
	pv->xline += BLANK;
	ShowMpg (wwk);
    }

    return req;
}
#if 0
static void WinRep (void)
{
    Warning ("Vnrow %d Vbars %d %d (%d %d %d)\n", aw0.nrow,
	     aw0.ypwcb->s[0].siz, aw0.ypwcb->s[0].stt, aw0.ysize,
	     ww.ysize, ww.xsize);
}
#endif
static short MultiPrint (struct WM_wwork *wwk)
{
    short i = 0, res = 0;
    short dodec = 0;
    short rv, ip;
    short np;
    int maxl;
    
    ip = pv->FaxPage;

    if (pv->PrtFlag == 2)
    {
	int l;
	for(l = 0; l < pv->qh.pagemax; l++)
	{
	    if(range[l] && Check4Scan(l) == 0)
	    {
		ShowStatus (wwk, 0, "Scanning fax file %s", pv->FileName);
		ScanFaxFile();
		break;
	    }
	}
    }
    
    np = 0;
    
    do
    {
	if(*(range+i))
	{
#ifdef DTEST
	    sd_pos (fgetchid (stdout), -1, i * 5, 16);
	    printf ("P %d", i);
	    fflush (stdout);
#endif

	    if(dodec || (pv->FaxPage != i))
	    {
		dodec = 1;
		memset (pv->scan, '\0', pv->maxmem);
#ifdef DTEST
	    sd_pos (fgetchid (stdout), -1, i * 5, 17);
	    printf ("D %d", i);
	    fflush (stdout);
#endif

		res = decode_fax2 (&maxl, i, skipbad, &badlines);
	    }
	    
	    if (res == 0 && pv->pabort == 0)
	    {
		PrintPage (np, NULL);
	    }
	    res = (pv->pabort == 2);
	    pv->FaxPage = i;
	    np++;
	}
	i++;

    } while (i < pv->qh.pagemax && res == 0);

    ClosePrt(0);
    
    if (pv->FaxPage == ip)
    {
	rv = 0;
    }
    else
    {
	rv = 3;
    }
    return rv;
}

static char *CheckArg (char ***pav, int *pac)
{
    char *p;
    char **av;

    av = *pav;

    if (*++(*av))
    {
	p = *av;
    }
    else if (*(av + 1) && **(av + 1) != '-')
    {
	p = *++av;
	*pac = *pac - 1;
    }
    else
    {
	p = NULL;
    }
    *pav = av;
    return p;
}

void FixPrtIni(void)
{
    int pac = 1;
    char **sav, **pav = malloc (8);
    char *str;

    pav[0] = "x";
    pav[1] = NULL;
    str = strdup(qd.pfaxini);

    FrigArgs (&pac, &pav, str);
    sav = pav;
    while (++pav, --pac)
    {
	char *p;

	if (**pav == '-')
	{
	    switch (*++(*pav))
	    {
	      case 'P':
		if ((p = CheckArg (&pav, &pac)) != NULL)
		{
		    mineop = atoi(p);
		}
		break;
		
	      case 't':
		if ((p = CheckArg (&pav, &pac)) != NULL)
		{
		    if(isdigit(*p))
		    {
			short t;
		    
			t = atoi (p);
			pv->xpl = XLateXPL (t, NULL);
		    }
		    else
		    {
			pv->xpl = XLateXPL(0, p);
		    }
		}

		if(pv->xpl == NULL || pv->xpl && pv->xpl->type > 99)
		{
		    pv->xpl = XLateXPL (0, NULL);
		}
		break;
		case 's':
		    if ((p = CheckArg (&pav, &pac)) != NULL)
			pv->specific = atoi (p);
		    break;
		case 'c':
		    if ((p = CheckArg (&pav, &pac)) != NULL)
			pv->compress = atoi (p);
		    break;
		case 'o':
		    if ((p = CheckArg (&pav, &pac)) != NULL)
			strcpy (pv->PrtName, p);
		    break;
	    }
	}
#if 0
	free (sav);
#endif
    }
    free(str);
}


static void FaxAction (struct WM_wwork *wwk)
{
    int n, key;
    short req = 0, clr = 0;
    int pid;
    short x, y;
    static short nd = 0;
    time_t ltim;

    switch (pv->DoAct)
    {
      case '+':
      case '-':
	clr = 1;
	if (pv->DoAct == '+')
	{
	    pv->FaxPage++;
	}
	else
	{
	    pv->FaxPage--;
	}
	req = LoadFile (wwk, 0);
	break;
	
      case 'F':
	if (lastTime)
	{
	    fact |= M_LAST;
	}
	else
	{
	    fact &= ~M_LAST;
	}
	n = MenuFax (wwk, fact);
	clr = 1;
	switch (n)
	{
	  case I_LAST:
	    if (!(lastTime = GetLastFile ()))
	    {
		pv->FaxPage = 0;
		*pv->FileName = '\0';
	    }
	  case I_LOAD:
	    if (*pv->FileName)
	    {
		req = LoadFile (wwk, 1);
	    }
	    break;
	  case I_PNEXT:
	  case I_PPREV:
	    if (n == I_PNEXT)
	    {
		pv->FaxPage++;
	    }
	    else
	    {
		pv->FaxPage--;
	    }
	    req = LoadFile (wwk, 0);
	    break;
	  case I_GOTO:
	    ScanReq = 1;
	    req = LoadFile (wwk, 0);
	    break;
	  case I_PRINT:
	    pv->pabort = 0;
	    if(*pv->PrtName == '\0')
	    {
		PRVIEW *prv;
	
		for(prv = qd.prview; prv; prv = prv->next)
		{
		    if(prv->value == pv->xpl->type)
		    {
			if(prv->file)
			{
			    strcpy(pv->PrtName, prv->file);
			}
		    }
		}
	    }

	    if(pv->fp)
	    {
		if(feof(pv->fp) || ferror(pv->fp))
		{
		    fclose(pv->fp);
		}
		else
		{
		    int res;
		    res = menu_choice (&ww, "Printer appears open, close it ?", 
				 2, 0, "Yes", "No");
		    if(res == 0)
		    {
			fclose(pv->fp);
		    }
		}
	    }
	    
	    if(*pv->PrtName == '|')
	    {
		pv->fp = popen (pv->PrtName+1, "w");
	    }
	    else
	    {
		if (*pv->PrtName == 0)
		{
		    sprintf (pv->PrtName, 
			     "prtqfax_%s", pv->xpl->name);
		}
		pv->fp = fopen (pv->PrtName, "w");
	    }
		    
	    if (pv->fp)
	    {
		IniPrt(&qd);
			
		pv->preq = SetRequester (NULL, pv->FileName);
		if (pv->PrtFlag == 0)
		{
		    int n = PrintPage (0, NULL);
		    ClosePrt(0);
		}
		else
		{
		    req = MultiPrint (wwk);
		    clr = req;
		}

		if(*pv->PrtName == '|')
		{
		    pclose(pv->fp);
		}
		else
		{
		    fclose (pv->fp);
		}
			
		ClearRequester (NULL);
		{
		    ShowMpg (wwk);
		}
	    }
	    else
	    {
		Report ("Failed to open printer");
	    }
	    pv->fp = NULL;
	    break;
	  case I_SETUP:
	    FixPrtIni();
	    break;
		    
	  case I_INFO:
	    FaxInfo (wwk, badlines);
	    break;
	  case I_FLIP:
	    {
		FlipMap ((unsigned char *) pv->scan, pv->F_char * (pv->xline + 1));
		req = 3;
	    }
	    break;
	}
	break;
      case 'M':
	if (fpQ)
	{
	    ShowMpg (wwk);
	}
	if (pv->xline)
	{
	    req = 3;
	    clr = 0;
	}
	break;
      case 'S':
	if (pv->xline && ScrollIt (aw0.ypwcb->s[0].stt))
	{
	    req = 2;
	}
	break;
      case 'P':
	if (pv->xline && PanIt (aw0.xpwcb->s[0].stt))
	{
	    req = 2;
	}
	break;
      case 'G':
      case 'T':
      case 't':
	if (pv->DoAct == 'G')
	{
	    x = lx;
	    y = ly;
	    key = 0;
	}
	else
	{
	    short tmp;

	    if (pv->DoAct == 'T')
	    {
		x = aw0.xsize + XBARS / 2;
		tmp = (aw0.ypwcb->s[0].siz > aw0.nrow) ? aw0.nrow : aw0.ypwcb->s[0].siz;
		y = ((int) ((aw0.ypwcb->s[0].stt + tmp / 2) * aw0.ysize)) / aw0.nrow;
	    }
	    else
	    {
		y = aw0.ysize + YBARS / 2;
		tmp = (aw0.xpwcb->s[0].siz > aw0.ncol) ? aw0.ncol : aw0.xpwcb->s[0].siz;
		x = ((int) ((aw0.xpwcb->s[0].stt + tmp / 2) * aw0.xsize)) / aw0.ncol;
	    }
	    key = -1;
	}
	n = setptr (pv->chan, -1, &x, &y, key);
	break;
    }
    if (req & 1)
    {
	ResetAll (wwk, clr);
    }
    if (req & 2)
    {
	if (req == 2)
	    wm_upbar (wwk, (struct WM_swdef *) &aw0, 0, 0);
	ShowLines ();
    }
#if 0
    WinRep ();
#endif
}

extern char *_sys_var;


main (int ac, char **av)
{
    int c;
    short i, dx = 0, dy = 0, lfl = 0;
    short atp = 0;
    struct WM_wsiz *wl;
    char *systyp;

    systyp = (strncmp (_sys_var, "S2AT", 4)) ? "QDOS" : "SMS2";

    for (i=1; i < ac; i++)
    {
	char *p = NULL;

	if (**(av+i) == '-')
	{
	    if (*(1+*(av+i)) == 'C')
	    {
		if (*(2+*(av+i)))
		{
		    p = (2+*(av+i));
		}
		else if (*(av + 1 +i) && **(av + 1 + i) != '-')
		{
		    p = *(av+i+1);
		}
		if (p)
		{
		    char t[80];
		    if(access(p, R_OK) == 0)
		    {
			sprintf(t,"QFAX_DATA=%s",p);
			putenv(t);
		    }
		}
		break;
	    }
	}
    }

    FaxParams (&qd);

    if (qd.qfv2ini)
    {
	FrigArgs (&ac, &av, qd.qfv2ini);
    }

    ww.chid = getchid (1);
    if (ww.chid < 0)
    {
	return -1;
    }

    if (!(wm_findv (ww.chid)))
    {
	return -1;
    }

    pv->chan = io_open ("scr", 0);
    strcpy (pv->FileName, qd.in_dir);
    strcpy (pv->PrtName, "prt");

    if (qd.pfaxini)
    {
	FixPrtIni();
    }

    pv->FaxPage = 0;

    while (++av, --ac)
    {
	char *p;

	if (**av == '-')
	{
	    switch (*++(*av))
	    {
	      case 'C':
		p = CheckArg (&av, &ac);
		break;

	      case 'P':
		if ((p = CheckArg (&av, &ac)) != NULL)
		{
		    mineop = atoi(p);
		}
		break;

	      case 'g':
		if ((p = CheckArg (&av, &ac)) != NULL)
		{
		    int pg = atoi(p);
		    if(pg) pv->FaxPage = pg-1;
		}
		break;
		
	      case 'J':
		skipall = 1;
	      case 'j':
		if ((p = CheckArg (&av, &ac)) != NULL)
		{
		    toskip = atoi(p);
		    if(skipall) skipall = toskip;
		}
		break;
		
	      case 'b':
		skipbad = 0;
		break;
	      case 'q':
		tf_opt = 1;
		break;
	      case 't':
		if ((p = CheckArg (&av, &ac)) != NULL)
		{
		    if(isdigit(*p))
		    {
			short t;
			t = atoi (p);
			pv->xpl = XLateXPL (t, NULL);
		    }
		    else
		    {
			pv->xpl = XLateXPL(0, p);
		    }
		}
		if(pv->xpl == NULL || pv->xpl && pv->xpl->type > 99)
		{
		    pv->xpl = XLateXPL (0, NULL);
		}
		break;
	      case 's':
		saveflag = 0;
		break;
	      case 'm':
		    if ((p = CheckArg (&av, &ac)) != NULL)
		    {
			pv->mag = atoi (p);
			if (pv->mag > 2)
			{
			    pv->mag = 2;
			}
			else if (pv->mag < 0)
			{
			    pv->mag = 0;
			}
		    }
		break;
	      case 'W':
		warn = 1;
		break;
	      case 'w':
		if ((p = CheckArg (&av, &ac)) != NULL)
		{
		    dx = atoi (p);
		    if (dx)
			{
			    dx = dx - ww.xsize;
			}
		}
		break;
	      case 'h':
		if ((p = CheckArg (&av, &ac)) != NULL)
		{
		    dy = atoi (p);
		    if (dy)
		    {
			dy = dy - ww.ysize;
			}
		}
		break;
	      case 'o':
		if ((p = CheckArg (&av, &ac)) != NULL)
		    strcpy (pv->PrtName, p);
		break;
	      case 'i':
		if ((p = CheckArg (&av, &ac)) != NULL)
		    strcpy (pv->FileName, p);
		break;
	      case 'l':
		lfl = lastTime = GetLastFile ();
		break;
	      case 'X':
		if ((p = CheckArg (&av, &ac)) != NULL)
		{
		    memlimit = atoi (p);
		    if (memlimit < MIN_MEM)
		    {
			memlimit = 120000;
		    }
		}
		break;
	      case 'z':
		zflag = 1;
		break;
	      case '3':
		*qd.mono = 3;
		break;
	      case 'p':
		atp = 1;
		break;
	    }
	}
	else if (lfl == 0)
	{
	    strcpy (pv->FileName, *av);
	    lfl = 1;
	}
    }

    if (lfl == 0)
    {
	lastTime = (time_t) CheckLastFile ();
    }

    if(pv->xpl == NULL || pv->xpl && pv->xpl->type > 99)
    {
	pv->xpl = XLateXPL (0, NULL);
    }
    
    MTEXT.chrs[0] = pv->mag + '0';

    ws.wwork = &ww;		/* set cross reference */

    aw0.ypwcb->nsec = 1;
    aw0.xpwcb->nsec = 1;

    wl = GetLimits (&ww);

    if (dx || dy)
    {
	re_scale (&ww, &dx, &dy);
    }

    if (!(((*qd.mono) & 1)))
    {
	infw[0].papr = 84;
    }

    if (atp)
    {
	dx = dy = -1;
    }
    else
    {
	dx = (wl->xsize - ww.xsize) / 2;
	dy = (wl->ysize - ww.ysize) / 2;
    }

    ws.litem[LI_PREV] = ws.litem[LI_NEXT] = WSI_UNAV;

    wm_prpos (&ww, dx, dy);
    wm_wdraw (&ww);

    lx = ww.wstat->ptpsx;
    ly = ww.wstat->ptpsy;

    ShowStatus (&ww, -1, " qfv: %s Fax Viewer (c) Jonathan Hudson 1994-97", systyp);

    if (qd.nodata == 1)
    {
	Report ("Couldn't find QFAX_DAT, using defaults");
    }
    if (lfl)
    {
	if (LoadFile (&ww, 1))
	{
	    ResetAll (&ww, 1);
	    ShowLines ();
	}
    }
    while (1)
    {
	wm_rptr (&ww);

	if (ws.evnt & PT_ZZZZ)
	{
	    Doze (1);
	}

	if (ws.evnt & PT_WAKE)
	{
	    ADRAW (&ww, (struct WM_appw *) &aw0);
	    lit_reset (&ww, 2);
	}

	if (ws.evnt & PT_WSIZE)
	{
	    aw0.xsize = ww.xsize - AWXOFF;
	    aw0.ysize = ww.ysize - AWYOFF;
	    /* If we don't do a resize, we MUST restore the correct APW
	     * size or its BLACK Hole time again.....
	     */
	    if (re_size (&ww, 1) == 0)
	    {
		aw0.xsize = ww.xsize - AWXOFF - XBARS;
		aw0.ysize = ww.ysize - AWYOFF - YBARS;
	    }
	    pv->DoAct = 0;
	}

	if ((ws.evnt & PT_DO) && pv->DoAct)
	{
	    FaxAction (&ww);
	    pv->DoAct = 0;
	}
    }

    io_close (pv->chan);
    wm_cluns (&ww);

    return (0);
}

static long AEXIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    if (tf_opt && wwk->wstat->kstk == 27)
    {
	int n;

	n = menu_choice (wwk, "Really quit ?", 2, 0, "No", "Yes");
	if (n != 1)
	{
	    return 0;
	}
    }
    exit (0);
}

/* 
 * Draw action routine
 * n.b. makes room for scroll bars (8 pixels)
 */

static long ADRAW (struct WM_wwork *wwk, struct WM_appw *apw)
{

    aw0.xsize = wwk->xsize - AWXOFF - XBARS;
    aw0.ysize = wwk->ysize - AWYOFF - YBARS;

    wm_swdef (wwk, apw, pv->chan);

    if (pv->xline)
    {
	ShowMpg (wwk);
	if (ssaved == NULL)
	{
	    ResetAll (wwk, bflag);	/* was above the showstatus */

	    ShowLines ();
	}
	else
	{
	    int sts;

	    sts = iop_wrst (pv->chan, -1, ssaved, 1);
	    free (ssaved);
	    ssaved = NULL;
	}
	wm_index (wwk, (struct WM_swdef *) &aw0);
    }
    return 0;
}

/* 
 * Hit routine, calculate displacement (iline) and set a DO event
 * (From a keystroke in window event)
 */

#define ALT_UP      0xd1
#define ALT_DOWN    0xd9
#define ALT_LEFT    0xc1
#define ALT_RIGHT   0xc9

static long AHIT (struct WM_wwork *wwk, struct WM_appw *apw,
		  struct WM_wstat *wst, short x, short y, short evnt)
{

    pv->DoAct = 0;
    switch (evnt)
    {
	case K_HIT:
	case ALT_UP:
	    pv->DoAct = 'S';
	    Checkystt (aw0.ypwcb->s[0].stt - aw0.ypwcb->s[0].siz);
	    break;
	case K_DO:
	case ALT_DOWN:
	    pv->DoAct = 'S';
	    Checkystt (aw0.ypwcb->s[0].stt + aw0.ypwcb->s[0].siz);
	    break;
	case ALT_LEFT:
	    pv->DoAct = 'P';
	    Checkxstt (aw0.xpwcb->s[0].stt - aw0.xpwcb->s[0].siz);
	    break;
	case ALT_RIGHT:
	    pv->DoAct = 'P';
	    Checkxstt (aw0.xpwcb->s[0].stt + aw0.xpwcb->s[0].siz);
	    break;
    }
    if (pv->DoAct)
    {
	wst->evnt |= PT_DO;
    }
    return AHIT_NORMAL;
}

static long AICON (struct WM_wwork *wwk, struct WM_litm *li)
{
    pv->DoAct = 'F';
    lit_reset (wwk, li->item);
    return PT__DO;
}
static long MMOVE (struct WM_wwork *wwk)
{
    short dx, dy;

    wwk->wstat->evnt |= PT_WMOVE;	/* set event bit for wm_chwin */
    wm_chwin (wwk, &dx, &dy);	/* move window */
    wm_swdef (wwk, (struct WM_appw *) &aw0, pv->chan);
    return lit_reset (wwk, 0);	/* and return */
}

static long ACTRL (struct WM_wwork *wwk, struct WM_appw *apw, struct WM_wstat *wst, short bpos, short blen, short item, short evnt)
{
    if ((evnt & 0xf) == 0xa)
    {
	Checkxstt ((((aw0.ncol * bpos / blen) - 4) / 8) * 8);
	pv->DoAct = 'P';
    }
    else
    {
	Checkystt ((((aw0.nrow * bpos / blen) - 8) / 16) * 16);
	pv->DoAct = 'S';
    }
    return PT__DO;
}
static long MEDIT (struct WM_wwork *wwk, struct WM_litm *li)
{
    char c;
    int act = 0;

    wm_swlit (wwk, li->item, WSI_SLCT);
    sd_clear (wwk->chid, -1);
    sd_cure (wwk->chid, -1);
    io_fbyte (wwk->chid, -1, &c);
    sd_curs (wwk->chid, -1);
    if (c >= '0' && c < '3')
    {
	MTEXT.chrs[0] = c;
	pv->mag = c - '0';
	pv->DoAct = 'M';
	act = PT__DO;
    }
    lit_reset (wwk, li->item);
    return act;
}

static long ASLEEP (struct WM_wwork *wwk, struct WM_litm *li)
{
    lit_reset (wwk, li->item);
    return PT__ZZZZ;
}

static long MARRAS (struct WM_wwork *wwk, struct WM_litm *li)
{
    pv->DoAct = (li->item == LI_NEXT) ? '+' : '-';
    return PT__DO;
}

static long MBARS (struct WM_wwork *wwk, struct WM_litm *li)
{
    short ix, iy, inx, iny;

    ix = wwk->xorg + wwk->xsize - wwk->wstat->ptpsx;
    iy = wwk->yorg + wwk->ysize - wwk->wstat->ptpsy;

    inx = (ix >= 0 && ix < XBARS);
    iny = (iy >= 0 && iy < YBARS);


    if (li->item == LI_BARTAB)
    {
	if (inx)
	{
	    pv->DoAct = 'G';
	}
	else
	{
	    if (!iny)
	    {
		lx = wwk->wstat->ptpsx;
		ly = wwk->wstat->ptpsy;
	    }
	    pv->DoAct = 'T';
	}
    }
    else
    {
	if (iny)
	{
	    pv->DoAct = 'G';
	}
	else
	{
	    if (!inx)
	    {
		lx = wwk->wstat->ptpsx;
		ly = wwk->wstat->ptpsy;
	    }
	    pv->DoAct = 't';
	}
    }
    return PT__DO;
}


