#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "qfv.h"

#define RETITM 39

Prototype MenuFax (struct WM_wwork *, short);
Prototype int GetFileName (struct WM_wwork *, char *, char *, int, int, int);

static long FAXREVIEW (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long FAXOPEN (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long FAXPAGE (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long FAXGOTO (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long FAXPRINT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long FAXPSET (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row);
static long MESC (struct WM_wwork *wwk, struct WM_litm *li);

static struct WM_action faxreview = {JSR, wm_actme, FAXREVIEW};
static struct WM_action faxopen = {JSR, wm_actme, FAXOPEN};
static struct WM_action faxprint = {JSR, wm_actme, FAXPRINT};
static struct WM_action faxpset = {JSR, wm_actme, FAXPSET};
static struct WM_action faxpage = {JSR, wm_actme, FAXPAGE};
static struct WM_action faxgoto = {JSR, wm_actme, FAXGOTO};
static struct WM_action mesc = {JSR, wm_actli, MESC};

static QD_TEXTI (ESCAPE, "Quit");

static QD_TEXTI (fm0, "Load fax ...");
static QD_TEXTI (fm1, "Next page");
static QD_TEXTI (fm2, "Prev page");
static QD_TEXTI (fm2a,"Goto page");
static QD_TEXTI (fm3, "Last fax");
static QD_TEXTI (fm4, "Review ...");
static QD_TEXTI (fm5, "Print ...");
static QD_TEXTI (fm6, "Setup ...");
static QD_TEXTI (fm7, "Info >>");
static QD_TEXTI (fm8, "Flip");

/* The following code builds up the menu structures. A bit daft you might think
 * have it in a linked list like this. Well yes, and no. It's done like this
 * because this is how I did it in QTPI where the XPR library list and the phone book
 * list are really menus, but dynamic ones, created (in alphabetical order) at run time
 * (you can add and delete phone entries, change the disk the XPRs are on etc). So a
 *  linked list is an ideal structure for such things, a little overkill here though,
 * where the entries are static.
 */

static MDEF Fm[] =
{
    {(QD_text_t *) & fm0, -1, WSI_AVBL, PT_CAN, &faxopen},
    {(QD_text_t *) & fm1, -1, WSI_AVBL, PT_CAN, &faxpage},
    {(QD_text_t *) & fm2, -2, WSI_AVBL, PT_CAN, &faxpage},
    {(QD_text_t *) & fm2a,-1, WSI_AVBL, PT_CAN, &faxgoto},
    {(QD_text_t *) & fm3, -8, WSI_AVBL, PT_CAN, &faxpage},
    {(QD_text_t *) & fm4, -3, WSI_AVBL, PT_CAN, &faxreview},
    {(QD_text_t *) & fm5, -1, WSI_AVBL, PT_CAN, &faxprint},
    {(QD_text_t *) & fm6, -1, WSI_AVBL, PT_CAN, &faxpset},
    {(QD_text_t *) & fm7, -1, WSI_AVBL, PT_CAN, &faxpage},
    {(QD_text_t *) & fm8, -1, WSI_AVBL, PT_CAN, &faxpage}
};

/* Defining _FMenu_ as external is a cunning stunt that allow us to make forward
// declaraions, which c68 doesn't really allow.
// i.e. _FMenu_[0].Next = &_FMenu_[1]
// Remove the extern declaration and it won't compile.
 */
extern LLIST _FMenu_[];
LLIST _FMenu_[] =
{
    {&_FMenu_[1], &Fm[0]},
    {&_FMenu_[2], &Fm[1]},
    {&_FMenu_[3], &Fm[2]},
    {&_FMenu_[4], &Fm[3]},
    {&_FMenu_[5], &Fm[4]},
    {&_FMenu_[6], &Fm[5]},
    {&_FMenu_[7], &Fm[6]},
    {&_FMenu_[8], &Fm[7]},
    {&_FMenu_[9], &Fm[8]},
    {NULL, &Fm[9]}
};


#define FMITEMS 10

static struct WM_litm d_litm[2] =	/* loose item */
{
    {24, 10,			/* xsize, ysize         size */
     100, 2,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, 3,		/* type, skey           type and select key */
     &ESCAPE,			/* *pobj                pointer to object */
     0,				/* item                 item number */
     &mesc},			/* *pact                pointer to action */
    {-1, -1}
};

static struct WM_litm p_litm[2] =	/* loose item */
{
    {24, 10,			/* xsize, ysize         size */
     200, 2,			/* xorg, yorg           and origin */
     0, 0,			/* xjst, yjst           justification */
     TYP_TEXT, 3,		/* type, skey           type and select key */
     &ESCAPE,			/* *pobj                pointer to object */
     0,				/* item                 item number */
     &mesc},			/* *pact                pointer to action */
    {-1, -1}
};

extern int exists (char *);

static PLLIST RFxList = NULL;
static int RFxNum;
int BuildFaxMenu (PLLIST *);
void FreeFaxList (PLLIST *);
extern char range [];

MenuFax (struct WM_wwork *wwk, short flag)
{
    int opt;
    PLLIST p = _FMenu_;
    short i;

    if ((RFxNum = BuildFaxMenu (&RFxList)) > 0)
    {
	flag |= M_REV;
    }

    for (i = 0; i < FMITEMS; i++)
    {
	if ((1 << i) & flag)
	{
	    Fm[i].status = WSI_AVBL;
	}
	else
	{
	    Fm[i].status = WSI_UNAV;
	}
    }
    opt = menu (wwk, "Fax Menu", &p, FMITEMS, 50, 50, 180, 0, d_litm, 1);
    if (RFxNum > 0)
    {
	FreeFaxList (&RFxList);
    }
    return opt;
}

static long FAXPAGE (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;

    mobj = mw->rowl[row].rows;
    wwk->wstat->litem[RETITM] = mobj->item;
    return PT__CAN;
}
static long FAXGOTO (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    char title[40], numb[20];
    int n,pn;
    
    mobj = mw->rowl[row].rows;
    sprintf(title,"Page number 1-%d",  pv->qh.pagemax);

    *numb = 0;
   
    do
    {
	n = menu_text (wwk, title, numb, 19);
	if(n >= 0)
	{
	    pn = strtol(numb, NULL, 10);
	    if(pn > 0 && pn <= pv->qh.pagemax)
	    {
		pv->FaxPage = pn - 1;
	    }
	    else 
	    {
		n = 0;
	    }
	}
	
    } while (n == 0);

    if (n > 0)
    {
	wwk->wstat->litem[RETITM] = I_GOTO;
    }
    else
    {
	wwk->wstat->litem[RETITM] = -1;
    }
    return PT__CAN;
}

#include <things.h>
#include "menus.h"

#define MOVEIN(s, t) s.len = strlen(t); strcpy((char *)s.chrs, t)

static void restore (char *buf, struct QD_text *qdt)
{
    strncpy (buf, (char *) qdt->chrs, qdt->len);
    *(buf + qdt->len) = '\0';
}

#define PACK(a,b,c,d) (d + (c << 8) + (b << 16) + (a << 24))

static const short
 use_thg[] =
{0x206F, 0x0004,		/*      move.l  4(sp),a0 */
 0x226F, 0x0008,		/*      move.l  8(sp),a1 */
 0x4E90,			/*      jsr     (a0)     */
 0x4E75};			/*      rts              */

int GetMenuFile (char *prompt, char *dirs, char *buf)
{
    int i;
    char extn[18];
    long vers;

    /*
     * We must ensure this is on an even boundary
     */

    static const long fsel = pack ('F', 'S', 'E', 'L');
    void *ps = NULL;
    char *p;
    THING_HEADER_EXT *pThing;


    static QD_TEXT (39) menustr;
    static QD_TEXT (39) basestr;
    static QD_TEXT (39) direstr;
    static QD_TEXT (39) rsltstr;
    static QD_TEXT (39) extstr;

    static MENUFS s =
    {
	{THP_CALL | THP_OPT | THP_STR, 0, &menustr},
	{THP_CALL | THP_OPT | THP_STR, 0, &basestr},
	{THP_CALL | THP_OPT | THP_STR | THP_UPD, 0, &direstr},
	{THP_CALL | THP_OPT | THP_STR, 0, &extstr},
	0,
	0,
	0,
	-1,
	-1,
	{THP_RET | THP_STR, 39, &rsltstr}
    };

    strcpy (extn, qd.suffix);

    MOVEIN (menustr, prompt);
    MOVEIN (basestr, buf);
    MOVEIN (direstr, dirs);
    MOVEIN (extstr, extn);

    rsltstr.len = 0;

    i = (int) sms_uthg ("Menus", -1, -1, (long *) &fsel, NULL, &vers, &ps);
    if (i > 0)
    {
	int (*func) (void *, MENUFS *) = (int (*)()) use_thg;

	pThing = (THING_HEADER_EXT *) i;
/*
 * c68 doesn't allow   ((int(*)()) use_thg) (pThing->thh_code, &s);
 * where use_thg isn't really a function.
 */
	i = (func) (pThing->thh_code, &s);
	if (i >= 0)
	{
	    restore (buf, (struct QD_text *) &rsltstr);
	    restore (dirs, (struct QD_text *) &direstr);
	}
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }

    return i;
}
static long FAXREVIEW (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    extern int DoFaxMenu (struct WM_wwork *wwk, PLLIST *, int, struct WM_litm *, int);

    int n;

    n = DoFaxMenu (wwk, &RFxList, RFxNum, p_litm, 1);
    if (n >= 0)
    {
	wwk->wstat->litem[RETITM] = I_LOAD;
    }
    else
    {
	wwk->wstat->litem[RETITM] = -1;
    }
    return PT__CAN;
}

static void CheckFPage(char *s)
{
    char *p;
    if((p = strrchr(s, '@')))
    {
	int n;
	*p = 0;
	
	if((n = strtol(p+1, NULL, 10)))
	{
	    pv->FaxPage = n-1;
	}
    }
}

static long FAXOPEN (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;
    int sv;
    char tmp[40];
    
    sv = pv->FaxPage;
    pv->FaxPage = 0;
    strcpy(tmp, pv->FileName);
    
    n = GetMenuFile ("Fax File", qd.in_dir, pv->FileName);

    if (n < 0 && n != -4)
    {
	n = GetFileName (wwk, "Fax File", pv->FileName, 40, OLD_SHARE, 1);
    }
    else
    {
	CheckFPage(pv->FileName);
	if (n == 0)
	{
	    n = 1;
	}
	else
	{
	    n = 0;
	}
    }
    if (n > 0)
    {
	wwk->wstat->litem[RETITM] = I_LOAD;
    }
    else
    {
	wwk->wstat->litem[RETITM] = -1;
	pv->FaxPage = sv;
	strcpy(pv->FileName, tmp);
    }
    return PT__CAN;
}

static long FAXPSET (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{
    struct WM_mobj *mobj;
    int n;
    char p [61];

    if(qd.pfaxini)
    {
	strcpy(p, qd.pfaxini);
    }
    else
    {
	*p = '\0';
    }
    
    n = menu_text (wwk, "Edit PFAXINI String", p, 59);

    if (n > 0)
    {
	wwk->wstat->litem[RETITM] = I_SETUP;
	if(qd.pfaxini)
	{
	    free(qd.pfaxini);
	}
	qd.pfaxini = strdup(p);
    }
    else
    {
	wwk->wstat->litem[RETITM] = -1;
    }
    return PT__CAN;
}

static void addrange(char *buf, char *range, int nn)
{
    char *p,*q;
    short j,n,ln = 0;
    
    memset(range, 0, nn);
    for(p = buf; *p && (n = strtol(p, &q, 0)); p = q+1)
    {
	switch(*q)
	{
   	  case ':':
	  case '-':
	    ln = n;
	    break;
	    
	  case ',':
	  case '\0':
	    if(ln)
	    {
		for(j = ln; j <= n; j++)
		{
		    range[j-1]++;
		}
		ln = 0;
	    }
	    else
		range[n-1]++;
	    break;
	}
    }
}


static long FAXPRINT (struct WM_wwork *wwk, struct WM_menw *mw, char *mst, short col, short row)
{

    struct WM_mobj *mobj;
    int n;
    short t;
    
    wwk->wstat->litem[RETITM] = -1;
    if (pv->xline)
    {
	n = GetFileName (wwk, "Print To", pv->PrtName, 40, NEW_EXCL, 1);
	if (n > 0)
	{
	    t = menu_choice (wwk, "Printer Type", 
				       4, pv->xpl->type, "HP PCL", 
				       "24 pin Epson", "9 pin Epson",
				       "Postscript");
	    if(t >= 0)
	    {
		pv->xpl = XLateXPL (t, NULL);

		if(pv->xpl == NULL)
		{
		    pv->xpl = XLateXPL (0, NULL);
		}

		pv->PrtFlag = menu_choice (wwk, "Print What ?", 3, 0, 
					   "This Page", "Whole Fax", 
					   "Range");
		if (pv->PrtFlag >= 0)
		{
		    if(pv->PrtFlag == 2)
		    {
			int sts;
			char buf[40];
			*buf = 0;
			
			sts  = menu_text (wwk, "Enter Range (a,b,c-d,e etc)",
					  buf, 40);
			if(sts > 0)
			{
			    addrange (buf, range, 256);
			    wwk->wstat->litem[RETITM] = I_PRINT;
			}
		    }
		    else
		    {
			wwk->wstat->litem[RETITM] = I_PRINT;
			if(pv->PrtFlag == 1)
			{
			    int k;
			    
			    memset(range, 0, 256);
			    for(k = 0; k < pv->qh.pagemax; k++)
			    {
				range[k] = 1;
			    }
			}
		    }
		}
	    }
	}
    }
    else
    {
	menu_choice (wwk, "No Fax loaded", 1, 0, "OK");
    }
    return PT__CAN;
}

int GetFileName (struct WM_wwork *wwk, char *prompt, char *text,
		 int maxc, int type, int query)
{
    int done = 0;
    int n, k;
    char temp[80];

    /* save user buffer */

    strcpy (temp, text);
    do
    {
	n = menu_text (wwk, prompt, temp, maxc);
	CheckFPage(temp);
	if (n < 0)
	{
	    done = TRUE;
	}
	else
	{
	    if (type >= NEW_EXCL)
	    {
		if (query == FALSE || type == NEW_EXCL)
		{
		    done = TRUE;
		    strcpy (text, temp);
		}
		else
		{
		    if (exists (temp))
		    {
			k = menu_choice (wwk, "File exists, overwrite ?", 3, 1, "Yes", "No", "Quit");
			if (k == 0)
			{
			    done = TRUE;
			    strcpy (text, temp);
			}
			else if (k == 2)
			{
			    done = TRUE;
			    n = -1;
			}
		    }
		    else
		    {
			done = TRUE;
			strcpy (text, temp);
		    }
		}
	    }
#ifdef MYREQ
	    else
	    {
		if (exists (temp))
		{
		    done = TRUE;
		    strcpy (text, temp);
		}
		else
		{
		    k = menu_choice (wwk, "File not found", 2, 0, "OK", "Quit");
		    if (k == 1)
		    {
			done = TRUE;
			n = -1;
		    }
		}
	    }
#endif
	}
    }
    while (!done);
    return n;
}

static long MESC (struct WM_wwork *wwk, struct WM_litm *li)
{
    wwk->wstat->litem[RETITM] = -1;
    lit_reset (wwk, li->item);
    return PT__CAN;		/* and return CAN event */
}
