#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdarg.h>
#include <string.h>

#include "text2g3.h"

static struct fmsg
{
    char *prompt;
    short xp;
    short yp;
    short clr;
} f[] = {   {"File  : ", 0, 0, 1},
            {"Format: ", 0, 1, 0}, {"Size : ", 36, 1, 1},
            {"Page  : ", 0, 2, 0}, {"Line : ", 36, 2, 0},
            {"Extra : ", 0, 3, 1},
            {"Msg   : ", 0, 4, 1}
        };
 
#define NMSG (sizeof(f)/sizeof(struct fmsg))

static void PosCsr(short x, short y)
{
    printf("\033[%d;%dH", y+1, x+1);
}

void InitWindow (short dummy)
{
    short i;
    
    fputs ("\033[H\033[2J", stdout);
    for(i = 0; i < NMSG; i++)
    {
        PosCsr(f[i].xp, f[i].yp);
        fputs(f[i].prompt, stdout);
    }
    fflush(stdout);
}
void Update (short act, char *fmt,...)
{
    va_list ap;
    va_start (ap, fmt);

    PosCsr(f[act].xp + strlen(f[act].prompt), f[act].yp);
    vprintf (fmt, ap);
    if(f[act].clr)
    {
        fputs("\033[0K", stdout);
    }
    fflush(stdout);
    va_end (ap);
}
void MyExit(short wait, int n)
{
    puts("\n");
    exit(n);        
}
#ifdef TEST
int main(void)
{
    InitWindow(0);
    return 0;
}
#endif
