#ifndef _QFV_
#define _QFV_H
#include "qheader.h"
#include "qfaxparse.h"
#include <limits.h>

typedef struct
{
    char *scan;                     /* Scan image */
    char  FileName[PATH_MAX];             /* File name */
    char  PrtName[PATH_MAX];              /* Print name/device */
    void  *fp;
    void  *preq;
    long fbytes;
    short interact;
    short specific;
    short xline;                    /*  */
    XPL *xpl;                       /* Printer flag */
    short pabort;
    short ysize;
    short compress;
    short paper;
    short buck;                     /* Stops here !!! */
    short maxwid;
    short FaxPage;
    long  maxmem;
    QFAXHEADER qh;
} VIEWPORT, *PVIEWPORT;

extern PVIEWPORT pv;
extern short pixwid[];
extern short pixhgt[];

#define HPPCL   0
#define EPSON24 1
#define EPSON09 2
#define PS      3
#define GIF     103
#define QTIFFR  105
#define QTIFFP  106
#define QTIFFZ  107

#define PAPER_A4    0
#define PAPER_LTR   1
#define PAPER_LGL   2

typedef unsigned char byte;
typedef unsigned short word;
#ifndef __linux__
typedef unsigned int uint;
#endif

extern char *SetRequester(void *, void *);
extern int CheckPrAbort(void *);
extern void ClearRequester(void *);
extern void ClosePrt(int);

#define SLACK 20


extern void Report (char *,...);
extern void Warning (char *,...);

#ifdef __linux__
#define clrmem(p1,p2) bzero(p1,p2)
#endif

#ifdef __linux__
ushort swapword (ushort val);
ulong swaplong (ulong val);
#else
#define swapword(v) (v)
#define swaplong(v) (v)
#endif
#endif







