#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#ifndef __NT__
#include <memory.h>
#endif
#include "qfv.h"
#include "fax2ps.h"

#define PLINLEN  8640

static unsigned char faxbits[8] = {0x80, 0x40, 0x20, 0x10, 0x8, 0x4, 0x2, 0x1};

static short F_pix;
static short F_char;
static short F_page;

#ifndef PRTFAX
#define ShowSize()
#define ShowPlace(p1)
#else
extern void ShowSize(void);
extern void ShowPlace(int);
#endif

extern int mode2compress (void *, void *, void *);
extern int mode3compress (int, void *, void *, void *);
extern int mode9compress(int, void *, void *, void *);

#define sdata       (char *) plin
#define CompData    (char *) (plin + 1024)
#define PrevData    (char *) (plin + 2048)
#define CompData3   (char *) (plin + 3072)

#define PCLLEN      320

#ifdef USESMOD
# undef USESMOD
#endif

#ifdef USESMOD 
extern short shmod(short a, short b);
#define SMOD(a,b) shmod(a,b)
#else
#define SMOD(a,b) (a % b)
#endif

static void Do9Pin (unsigned char *plin)
{
    char *ep;
    static char ini[4] =  {27, 'L', 0, 0};
    static short bcnt[] = {960, 1138, 1352};
    short max_col = bcnt[pv->qh.width];
    
    ep = sdata + max_col;
    while (*--ep == 0 && ep != sdata)
    {
	max_col--;
    }

    ini[2] = (max_col & 0xFF);
    ini[3] = (max_col >> 8);
    fwrite (ini, 1, 4, pv->fp);
    fwrite (plin, 1, max_col, pv->fp);
    fputs ("\n\r", pv->fp);
    bzero ((void *)plin, 1360);
}
#define CHECKFP if(feof(pv->fp) || ferror(pv->fp)) break

static void PrintEPSON09 (unsigned char *plin)
{

    static char init_string[] =
        {'\033', '@', '\033', 'P', '\033', 'l', 0, '\r', '\033', '3', '\030'};

    unsigned char *sp, *sptr;
    short i = 0, j;
    short p_pos, p_lin, max_col;

    sptr = (unsigned char *) pv->scan;
    p_lin = 0;

    fwrite (init_string, 1, 11, pv->fp);

    bzero ((void *)plin, 1360);

    while (i < pv->xline && pv->pabort == 0)
    {
	if (SMOD(i,3) == 0 || SMOD(i,50) == 0) /* Select only these lines as */
	{			/*   we want c. 800 from 2286 */
	    p_pos = 0;
	    max_col = 0;
	    for (j = 0; j < F_pix; j++)
	    {
		if (SMOD(j,2) == 1 || SMOD(j,18) == 0)  /* Likewise 960 pixels*/
		{		/*   from 1728 */
		    unsigned char c;

		    sp = sptr + (j >> 3);
		    c = *sp | *(sp + F_char);	/* Average two lines */
		    if (c & faxbits[j & 7])	/*  or is too weedy. */
		    {
			plin[p_pos] |= faxbits[p_lin];
		    }
		    p_pos++;
		}
	    }

	    p_lin++;
	    p_lin &= 7;

	    if (p_lin == 0)
	    {
		Do9Pin (plin);
	    }
	}
	i++;
        ShowPlace (i);
	sptr += F_char;
	CHECKFP;
    }
    if (p_lin)
    {
	Do9Pin (plin);
    }
    ShowPlace (pv->xline);
    fputs ("\f\033@", pv->fp);
}

static void PrintEPSON24 (unsigned char *plin)
{
    unsigned char *src_ptr, *ptr;
    short i = 0, j, k = 0, nl = 0;
    short bit_nr, p_pos, p_lin, p_bit, max_col;

    fputc ('\015', pv->fp);
    src_ptr = (unsigned char *) pv->scan;
    
    while (i < pv->xline && pv->pabort == 0)
    {
        bzero ((void *)plin, PLINLEN);
	max_col = 0;

	for (p_pos = j = 0; j < F_pix; j++)
	{
	    short jp,kp;
	    jp = j + 1;
	    
	    if (SMOD(jp,6))
	    {
		ptr = src_ptr + (j >> 3);
		
		bit_nr = j & 0x07;
		p_bit = p_pos & 0x07;
		for (p_lin = k = 0; p_lin < 24; k++)
		{
		    if (*ptr & faxbits[bit_nr])
			if ((plin[(p_pos >> 3)*24 + p_bit*3 + (p_lin >> 3)] |=
			     faxbits[p_lin & 0x07]) != 0)
			    max_col = p_pos;
		    kp = k + 1;
		    if (SMOD(kp,6))
		    {
			p_lin++;
		    }
		    ptr += F_char;
		}
		p_pos++;
	    }
	}
	i += k;
	src_ptr += (F_char * k);
	
	nl++;
        ShowPlace (i);

	if (max_col)
	{
	    unsigned char z;

	    max_col++;
	    fputs ("\033*\047", pv->fp);
	    z = (max_col & 0xFF);
	    fputc (z, pv->fp);
	    z = (max_col >> 8);
	    fputc (z, pv->fp);

	    fwrite (plin, 1, max_col * 3, pv->fp);
	}
	fputs ("\015\033\063\030\012\015", pv->fp);
	CHECKFP;
    }
    ShowPlace (pv->xline);
    fputc ('\f', pv->fp);
}

#ifndef USESMOD
static short CheckHS (short pos)
{
    short act = 1;

    switch (pv->qh.width)
    {
	case 0:
            if(pv->specific & 4)
            {
                if(pos & 1 && pos & 0x2e)
                {
                    act = 2;
                }
            }
            else
            {
	        if (!SMOD(pos,3) || !SMOD(pos,14) || !SMOD(pos,74))
	        {
		    act = 2;
	        }
	    }
	    break;
	case 1:
	    if (!SMOD(pos,6) || !SMOD(pos,105))
	    {
		act = 2;
	    }
	    break;
	case 2:
	    if (!SMOD(pos,76))
	    {
		act = 0;
	    }
	    break;
    }
    return act;
}

static short CheckVS (short pos)
{
    short act = 1;

    switch (pv->qh.width)
    {
	case 0:
            if(pv->specific & 4)
            {
                if(pos & 1 && pos & 0x2e)
                {
                    act = 2;
                }
            }
            else
            {            
	        if (pv->paper == PAPER_A4)
	        {
		    if (!SMOD(pos,3) || !SMOD(pos,7) || !SMOD(pos,34))
		    {
		        act = 2;
		    }
	        }
	        else
	        {   
		    if (!SMOD(pos,3) || !SMOD(pos,16) || !SMOD(pos,178))
		    {
		        act = 2;
		    }
		}
	    }
	    break;
	case 1:
	    if (pv->paper == PAPER_A4)
	    {
		if (!SMOD(pos,7) || !SMOD(pos,24))
		{
		    act = 2;
		}
	    }
	    else
	    {
		if (!SMOD(pos,9) || !SMOD(pos,73))
		{
		    act = 2;
		}
	    }
	    break;
	case 2:
	    if (pv->paper == PAPER_A4)
	    {
		if (!SMOD(pos,37))
		{
		    act = 2;
		}
	    }
	    else
	    {
		if (!SMOD(pos,48))
		{
		    act = 0;
		}
	    }
	    break;
    }
    return act;
}
#else
extern short CheckHS (short);
extern short CheckVS (short);
#endif

static void WriteHP (char *optr, int max_col, int num)
{
    char prl[32];
    int prl_len;
    int i;

    prl_len = sprintf (prl, "\033*b%dW", max_col);
    for (i = 0; i <= num; i++)
    {
	fwrite (prl, 1, prl_len, pv->fp);
	if (max_col)
	{
	    fwrite (optr, 1, max_col, pv->fp);
	}
    }
}


static int PrintHPPCL (unsigned char *plin)
{
    unsigned char *src_ptr;
    short gb;
    short pbit_nr, fbit_nr;
    short i = 0;
    short j,k;
    short max_col = 0;
    short bitset;
    short nhp = 0;
    short compress = 0;
    short nb = 0;
    short last;
    short lc = 0;
    short ls;
    short maxc;
    short rsn;

    bzero ((void *)PrevData, PCLLEN);
    rsn = (pv->specific & 2) ? 150 : (pv->specific & 8) ? 200 : 300;

    fprintf (pv->fp, "\033*t%dR", rsn);

    i = (F_pix < 2400) ? 2400 : F_pix;
    if (pv->specific & 1)
    {
	i = F_pix;
    }

    fprintf (pv->fp, "\033*r%4dS", i);

    fputs ("\033*r0A", pv->fp);	/* start rastergraphics    */
    if (pv->compress == 2)
    {
	fputs ("\033*b2M", pv->fp);
	compress = 2;
    }
    else if (pv->compress == 9)
    {
	fputs ("\033*b9M", pv->fp);
	compress = 9;
    }    

/*    printf("Last is %d\n", pv->xline); */
    src_ptr = (unsigned char *) pv->scan;
    
    for (i = 0; i <= pv->xline && pv->pabort == 0; i++, src_ptr += F_char)
    {
	short hskip, act;
	unsigned char *spt;
	
	ShowPlace (i);

	hskip = CheckVS (i);
	lc += hskip;
	if (!(pv->specific & 1))
	{
	    if (lc > F_page)
	    {
		fputs ("\033&l0H", pv->fp);
		fflush (pv->fp);
		lc = nb = 0;
	    }
	    if (hskip == 0)
	    {
		continue;
	    }
	}
	bzero ((void *)plin, PCLLEN * 2);
	fbit_nr = pbit_nr = 0;
	max_col = 0;
#if 0
	{
	    int ii = i;
	    unsigned char *tpr;
	    tpr = (unsigned char *) (pv->scan + (F_char * ii));
	    printf("Line %d %p %p\n", i, tpr, src_ptr);
	}
#endif
	
        if(pv->specific & 4)
        {
            ls = 3;
            maxc = F_char - 3;
        }
        else
        {
            ls = 0;
            maxc = F_char;
        }

	spt = src_ptr + ls;
	
	for (j = ls; j < maxc; j++)
	{
	    gb = *spt++;
	    if (gb)
	    {
		for (k = 0; k < 8; k++)
		{
		    short l;

		    if (!(pv->specific & 2) || (k & 1))
		    {
			bitset = (gb & faxbits[k]);
			if ((pv->specific & 1))
			{
			    act = 1;
			}
			else
			{
			    act = CheckHS (fbit_nr);
			}
			for (l = 0; l < act; l++)
			{
			    if (bitset)
			    {
				plin[pbit_nr >> 3] |= faxbits[pbit_nr & 0x07];
			    }
			    pbit_nr++;
			}
		    }
		    fbit_nr++;
		}
		max_col = (pbit_nr + 7) >> 3;
	    }
	    else
	    {
		if (pv->specific & 1)
		{
		    fbit_nr += 8;
		    pbit_nr += 8;
		}
		else
		{
		    for (k = 0; k < 8; k++)
		    {
			if (!(pv->specific & 2) || (k & 1))
			{
			    pbit_nr += CheckHS (fbit_nr);
			}
			fbit_nr++;
		    }
		}
	    }
	}

	nhp = 0;

	if (!(pv->specific & 1))
	{
	    nhp = hskip - 1;
	}

	if (max_col == 0)
	{
	    nb += (1 + nhp);
	}
	else
	{
	    if (nb)
	    {
                if (pv->compress == 3 || pv->compress == 9)
		{
		    bzero ((void *)PrevData, PCLLEN);
		    fputs ("\033*bY", pv->fp);
		}
		if (nb < 7 || pv->compress == 2)
		{
		    for (; nb; nb--)
		    {
			fputs ("\033*bW", pv->fp);
		    }
		}
		else if (pv->compress == 0)
		{
		    fprintf (pv->fp, "\033*p+%dY", nb);
		}
		else
		{
		    fprintf (pv->fp, "\033*b%dY", nb);
		}
		nb = 0;
	    }
	    switch (pv->compress)
	    {
		case 0:
	        case 1:
		    WriteHP (sdata, max_col + 1, nhp);
		    break;
		case 2:
		    last = (max_col + 2) & ~1;
		    max_col = mode2compress (sdata, sdata + last, CompData);
		    WriteHP (CompData, max_col, nhp);
		    break;
		case 3:
		    last = (max_col + 2) & ~1;
		    {
			int count3 = mode3compress (300, sdata, PrevData, CompData3);
			int count2 = mode2compress (sdata, sdata + last, CompData);
			short count0 = max_col;
			short penalty3 = (compress == 3) ? 0 : 5;
			short penalty2 = (compress == 2) ? 0 : 5;
			short penalty0 = (compress == 0) ? 0 : 5;

			if (count3 + penalty3 < count2 + penalty2)
			{
			    if (count3 + penalty3 < count0 + penalty0)
			    {
				if (compress != 3)
				{
				    fputs ("\033*b3M", pv->fp);
				    compress = 3;
				}
				WriteHP (CompData3, count3, 0);
				if (nhp)
				{
				    fputs ("\033*bW", pv->fp);
				}
			    }
			    else
			    {
				if (compress != 0)
				{
				    fputs ("\033*b0M", pv->fp);
				    compress = 0;
				}
				WriteHP (sdata, max_col + 1, nhp);
			    }
			}
			else
			{
			    if (compress != 2)
			    {
				fputs ("\033*b2M", pv->fp);
			    }
			    compress = 2;
			    WriteHP (CompData, count2, nhp);
			}
		    }
		    break;
                case 9:
                    {
                        int count;
                        count = mode9compress (300, sdata, PrevData, CompData3);
			WriteHP (CompData3, count, 0);
			if (nhp)
			{
			    fputs ("\033*bW", pv->fp);
			}
		    }
                    break;                
	    }
	}
	if (pv->specific & 2)
	{
	    i++;
	    src_ptr += F_char;
	}
	CHECKFP;
    }
    ShowPlace (pv->xline);
    fputs ("\033*rbC\033E\033&l0H", pv->fp);
    return 0;
}
#ifdef PRTFAX
void DumpMap(void)
{
    fprintf(pv->fp, "P4\n%d %d\n", F_pix, pv->xline);
    fwrite(pv->scan, F_char, pv->xline, pv->fp);
}

typedef struct 
{
    short flag;
    short xpix;
    short ypix;
    short llen;
    short mode;
} PICHEAD;

void DumpPic(byte *obuf)
{
    short rsize;
    byte *buf;
    short y,nl,flag,j;
    short line_size = (F_pix+7)/8;
    PICHEAD ph;    

    flag = (pv->xpl->type & 3) >> 1;
    rsize = ((2*((F_pix + 7) >> 3)) >> flag) + 4;
    
    fwrite(&ph, 1, sizeof(ph), pv->fp);

    for ( nl = y = 0; y < pv->xline; y++ )
    {
	short i;
	memset(obuf, 0, rsize);
	buf = (unsigned char *) (pv->scan + (F_char * y));
	if(y & (3 << flag))
	{
	    if(flag == 0)
	    {
		for (j = i = 0; i < line_size; i++, j += 2)
		{
		    obuf[j] = obuf[j+1] = ~buf[i];
		}
	    }
	    else if(flag == 1)
	    {
		for (j = i = 0; i < line_size; i += 2, j += 2)
		{
		    byte c,d;

		    c = buf[i+1];
		    d = 0;
		    if(c & 0x03) d |= 1;
		    if(c & 0x0c) d |= 2;
		    if(c & 0x30) d |= 4;
		    if(c & 0x80) d |= 8;
/***************************************************************
		    d = (c & 1) | ((c & 4) >> 1) | 
			((c & 0x10) >> 2) | ((c & 0x40) >> 3);
 **************************************************************/
		    c = buf[i];
		    if(c & 0x03) d |= 0x10;
		    if(c & 0x0c) d |= 0x20;
		    if(c & 0x30) d |= 0x40;
		    if(c & 0x80) d |= 0x80;
/***************************************************************
		    d |= ((c & 1) << 4) | ((c & 4) << 3) | 
			((c & 0x10) << 2) | ((c & 0x40) << 1);
 **************************************************************/
		    obuf[j] = obuf[j+1] = ~d;
		}
	    }
	    fwrite (obuf, 1, rsize, pv->fp);
	    nl++;
	}
	y += flag;
    }
    
    fseek(pv->fp, 0, 0); 
    ph.flag = SH(0x4afc);
    ph.xpix = SH(F_pix >> flag); 
    ph.ypix = SH(nl);    
    ph.llen = SH(rsize);
    ph.mode = 0;	
    fwrite(&ph, 1, sizeof(ph), pv->fp);
}

#if 0
static byte stbl[256] = 
{
    0x00,0x80,0x40,0xc0,0x20,0xa0,0x60,0xe0,
    0x10,0x90,0x50,0xd0,0x30,0xb0,0x70,0xf0,
    0x08,0x88,0x48,0xc8,0x28,0xa8,0x68,0xe8,
    0x18,0x98,0x58,0xd8,0x38,0xb8,0x78,0xf8,
    0x04,0x84,0x44,0xc4,0x24,0xa4,0x64,0xe4,
    0x14,0x94,0x54,0xd4,0x34,0xb4,0x74,0xf4,
    0x0c,0x8c,0x4c,0xcc,0x2c,0xac,0x6c,0xec,
    0x1c,0x9c,0x5c,0xdc,0x3c,0xbc,0x7c,0xfc,
    0x02,0x82,0x42,0xc2,0x22,0xa2,0x62,0xe2,
    0x12,0x92,0x52,0xd2,0x32,0xb2,0x72,0xf2,
    0x0a,0x8a,0x4a,0xca,0x2a,0xaa,0x6a,0xea,
    0x1a,0x9a,0x5a,0xda,0x3a,0xba,0x7a,0xfa,
    0x06,0x86,0x46,0xc6,0x26,0xa6,0x66,0xe6,
    0x16,0x96,0x56,0xd6,0x36,0xb6,0x76,0xf6,
    0x0e,0x8e,0x4e,0xce,0x2e,0xae,0x6e,0xee,
    0x1e,0x9e,0x5e,0xde,0x3e,0xbe,0x7e,0xfe,
    0x01,0x81,0x41,0xc1,0x21,0xa1,0x61,0xe1,
    0x11,0x91,0x51,0xd1,0x31,0xb1,0x71,0xf1,
    0x09,0x89,0x49,0xc9,0x29,0xa9,0x69,0xe9,
    0x19,0x99,0x59,0xd9,0x39,0xb9,0x79,0xf9,
    0x05,0x85,0x45,0xc5,0x25,0xa5,0x65,0xe5,
    0x15,0x95,0x55,0xd5,0x35,0xb5,0x75,0xf5,
    0x0d,0x8d,0x4d,0xcd,0x2d,0xad,0x6d,0xed,
    0x1d,0x9d,0x5d,0xdd,0x3d,0xbd,0x7d,0xfd,
    0x03,0x83,0x43,0xc3,0x23,0xa3,0x63,0xe3,
    0x13,0x93,0x53,0xd3,0x33,0xb3,0x73,0xf3,
    0x0b,0x8b,0x4b,0xcb,0x2b,0xab,0x6b,0xeb,
    0x1b,0x9b,0x5b,0xdb,0x3b,0xbb,0x7b,0xfb,
    0x07,0x87,0x47,0xc7,0x27,0xa7,0x67,0xe7,
    0x17,0x97,0x57,0xd7,0x37,0xb7,0x77,0xf7,
    0x0f,0x8f,0x4f,0xcf,0x2f,0xaf,0x6f,0xef,
    0x1f,0x9f,0x5f,0xdf,0x3f,0xbf,0x7f,0xff
};

void DumpXbm (void)
{
    byte c, *p;
    short y,j;
    short flag,bit;
    
    p = (byte *) pv->scan;
    flag = (pv->xpl->type & 1);           /* 1 = reduced */

    fprintf(pv->fp,"#define fax_width %d\n#define fax_height %d\n",
	    F_pix>>flag, pv->xline>>flag);
    fputs( "static char fax_bits[] = {\n", pv->fp);

    for (bit = y = 0; y < pv->xline; y++ )
    {

	for(j = 0; j < F_char; j++,p++)
	{
	    if(flag)
	    {
		static byte mask[]={0xc0,0x30,0xc,0x3};
		short k;
		
		c = 0;
		for(k = 0; k < 8; k++)
		{
		    if(k == 4)
		    {
			j++;
			p++;
		    }
		    if(*p & mask[k & 3])
		    {
			c |= (1 << k);
		    }
		}
	    }
	    else
	    {
		c = stbl[*p];
	    }
	    fprintf(pv->fp, "0x%02x,", c);
	}
	fputc('\n', pv->fp);
	if(flag)
	{
	    y++;
	    p += F_char;
	}
    }
    fputs("};\n", pv->fp);
}
#endif

extern int DoGif (FILE *, byte *, byte *, short, short, short);
extern void exitgif(FILE *);

void PrintGif (void *p, int pg)
{
    DoGif (pv->fp, (byte *) pv->scan, p, F_char, pv->xline, pg);
    if(pv->xpl->paged)
    {
	exitgif(pv->fp);
    }
}
#ifdef QFAX_TIFF
#include <tiffio.h>

static TIFF *OpenTIFF(int w, int h, char *fname, int comp)
{
  TIFF *tif;
  tif = TIFFOpen(fname, "w");
  if (!tif) return 0;

  TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, w);
  TIFFSetField(tif, TIFFTAG_IMAGELENGTH, h);
  TIFFSetField(tif, TIFFTAG_COMPRESSION, comp);
  TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
  TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, 1);
  TIFFSetField(tif, TIFFTAG_ORIENTATION, ORIENTATION_TOPLEFT);
  TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP, h);
  TIFFSetField(tif, TIFFTAG_FILLORDER, FILLORDER_MSB2LSB);
  TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, 1);
  TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_MINISWHITE);
  TIFFSetField(tif, TIFFTAG_RESOLUTIONUNIT, RESUNIT_INCH);
#if 0
  TIFFSetField(tif, TIFFTAG_XRESOLUTION, 204);
  TIFFSetField(tif, TIFFTAG_YRESOLUTION, 198);
#endif
  TIFFSetField(tif, TIFFTAG_SOFTWARE, "qfax - (c) Jonathan Hudson 1994");
  return tif;
}

static void PrintTIFF(void *p, int pg, short flag, char *fn)
{
    int comp;
    TIFF *tif;
    
    if(pv->fp)
    {
	fclose(pv->fp);
	unlink(fn);
    }
    comp = (flag == QTIFFR) ? COMPRESSION_NONE : 
	(flag == QTIFFP) ? COMPRESSION_PACKBITS : COMPRESSION_LZW;

    if((tif= OpenTIFF(F_pix, pv->xline, fn, comp)))
    {
	byte *buf = (unsigned char *) pv->scan;
	short i;
	
	for(i = 0; i < pv->xline; i++)
	{
	    TIFFWriteScanline(tif, buf, i, 0);	
	    buf += F_char;
        }
	TIFFClose(tif);
    }
}

#endif
#endif

static OFILE fps = {0};

void PrintPSPage(void *p, int pg)
{

    short i;
    unsigned char *buf;
    char cc[80];
    
    fps.f = pv->fp;
    fps.xres = 204.0;
    fps.yres = 196.0;
    fps.w = F_pix;
    fps.h = (pv->xline > 2280) ? pv->xline : 2280;
    
    fps.lastpageno = pv->qh.pagemax;
    fps.firstpsline = 0;

    sprintf(cc,"printfax %dd,%c (c) jrh 1996",
	    pv->qh.coding + 1,
	    pv->qh.resolution ? 'h' : 'l');
    
    PSnextopage(&fps, pg, cc);    
    buf = (unsigned char *) pv->scan;
    
    for(i = 0; i < pv->xline; i++)
    {
	PSwrite (&fps, buf,  F_char);    
	buf += F_char;
    }
    memset(p, 0, F_char);
    while(i++ < fps.h)
    {
	PSwrite (&fps, p,  F_char);    
    }
}

int PrintPage (int pg, char *fn)
{
    static short paperlen[] = {3300, 3150, 4000};
    static unsigned char *p = NULL;
    int rval = -1;

    F_pix = pixwid[pv->qh.width];
    F_char = F_pix >> 3;

    if(p == NULL)
    {
	p = (unsigned char *) malloc (PLINLEN);
    }
    
    if (p)
    {
	if(pv->xpl->show)
	{
	    ShowSize ();
	}
	switch (pv->xpl->type)
	{
	    case EPSON24:
		PrintEPSON24 (p);
		break;
	    case EPSON09:
		PrintEPSON09 (p);
		break;
	      case PS:
	      case PS+1:
		PrintPSPage(p,pg);
		break;
	    case HPPCL:
		F_page = paperlen[pv->paper];
                if(pv->paper == PAPER_A4 && pv->qh.width == 0 && pv->xline < 2242)
                {
                    pv->specific |= 4;
                }
                else
                {
                    pv->specific &= ~4;
		}
		PrintHPPCL (p);
		break;
#ifdef PRTFAX
	      case 100:
		DumpMap();
		break;
	      case 101:
	      case 102:
		DumpPic(p);
		break;
	      case GIF:
	      case GIF+1:
		PrintGif(p, (pv->xpl->paged) ? 0 : pg);
		break;
#ifdef QFAX_TIFF
	      case QTIFFR:
	      case QTIFFP:
	      case QTIFFZ:
		PrintTIFF(p, pg, pv->xpl->type, fn);
		pv->fp = NULL;
		break;
#endif
#endif
	    default:
		break;
	}
	rval = 0;
#if !defined(QDOS) && defined (PRTFAX)
        if(pv->xpl->show && pv->interact & 1)
        {
            putchar('\n');
        }
#endif
    }
    return rval;
}

void IniPrt(FAXDATA *qd)
{
    if (pv->xpl->type == HPPCL)
    {
	qd->paper &= 3;
	pv->paper &= 3;
	fputs ("\033E\033&l0L", pv->fp);	/* No skip over perforation */
	if (qd->paper != pv->paper)
	{
	    static char hps[] =
	    {26, 2, 3};
	    
	    fprintf (pv->fp, "\033&l%dA", hps[pv->paper]);
#ifdef PRTFAX
	    Report ("Using %s paper size",
		    (pv->paper == 0) ? "A4" :
		    (pv->paper == 1) ? "Ltr" : "Lgl");
#endif
	}
    }
}


void ClosePrt(int flag)
{
    switch (pv->xpl->type)
    {
      case EPSON24:
	fputs("\033@", pv->fp);
	break;
      case PS:
      case PS+1:
	PSnextopage(&fps, -1, NULL);
	memset(&fps, 0, sizeof(fps));
	break;
      case HPPCL:
	if (flag)
	{
	    fputs ("\033&l0A\033E", pv->fp);
	}
	break;
#ifdef PRTFAX
      case GIF:
	exitgif(pv->fp);
	break;
#endif
    }
}

