#include "forms.h"
#include "xfax.h"

#include <X11/Intrinsic.h>
#include "qfv.h"
#include "xfax_p.h"

extern FAXDATA qd;

void GetFaxPage(FD_fax *f, BITMAP *b, short iact)
{
    if(iact == MU_PPAGE)
    {
        pv->FaxPage--;
    }
    else
    {
        pv->FaxPage++;
    }
    LoadFax(f,b, 0);
}


void SetMenu (FD_fax *f, short fact)
{
    int i,j;
    unsigned int mode,val;
    
    for(i = 0; i < MU_ITEMS;)
    {
	j = (1 << i);
        mode =  (fact & j) ? FL_PUP_NONE : FL_PUP_GREY; 
	val = (fact & j);
	i++;
	fl_set_menu_item_mode(f->menu, i, mode);
	switch(i)
	{
	case 2:
	    f->button2->u_ldata = val;
	    f->button7->u_ldata = val;
	    break;
	case 4:
	    f->button5->u_ldata = val;
	    break;
	case 5:
	    f->button4->u_ldata = val;
	    break;
	case 6:
	    f->button6->u_ldata = val;
	    break;
	case 7:
	    f->button3->u_ldata = val;
	    break;
	}
    }
}

static void Checkpos(short *pos, Dimension d, short e)
{
    short l;
    
    l = d - e;
    if(*pos > l) *pos = l; 
    if(*pos < 0) *pos = 0;
}

void ys_cb(FL_OBJECT *ob, long data)
{
    double pos;
    FD_fax *f;
    BITMAP *b;

    f = ob->form->u_vdata;
    b =  (BITMAP *) f->vdata;

    pos = fl_get_slider_value (ob);
    b->cury = b->height * pos;
    Checkpos(&b->cury, b->height, ob->h);
    RefreshImage(f);
}

void xs_cb(FL_OBJECT *ob, long data)
{
    double pos;
    FD_fax *f;
    BITMAP *b;

    f = ob->form->u_vdata;
    b =  (BITMAP *) f->vdata;

    pos = fl_get_slider_value (ob);
    b->curx = b->width * pos;
    Checkpos(&b->curx, b->width, ob->w);
    RefreshImage(f);
}

void menu_cb(FL_OBJECT *ob, long data)
{
    BITMAP *b;
    FD_fax *f;

    int ni = fl_get_menu(ob);

    f = ob->form->u_vdata;
    b =  (BITMAP *) f->vdata;

    switch(ni)
    {
    case 1:
	button1_cb(ob, 0);
	break;
    case 2:
    case 3:
	DoPrint(f, b, (ni == 2) ? MU_PRINT :  MU_PRINTX);
	break;
    case 4:
	NextPage (f, b);
	break;
    case 5:
	PrevPage (f, b);
	break;
    case 6:
	NextFax (f, b);
	break;
    case 7:
	PrevFax (f, b);
	break;
    case 8:
	Invert (f, b);
	break;
    case 9:
	exit(0);
	break;
    }
}

void quit_cb(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
    exit(0);
}

void button1_cb(FL_OBJECT *ob, long data)
{
    FD_fax *f;
    BITMAP *b;
    const char *p;

    f = ob->form->u_vdata;
    b =  (BITMAP *) f->vdata;

    if((p = fl_show_fselector("Load a file", qd.in_dir, "*.fax",  NULL)))
    {
	pv->FaxPage = 0;
	GetBitMap(f, b, (char *)p);
	DrawImage(f);
    }
}

void button2_cb(FL_OBJECT *ob, long data)
{
    if(ob->u_ldata)
    {
	FD_fax *f;
	int nb;

	f = ob->form->u_vdata;
	nb = fl_get_button_numb(ob);
	DoPrint(f, f->vdata, (nb==1) ? MU_PRINT :  MU_PRINTX);
    }
}

void button3_cb(FL_OBJECT *ob, long data)
{

    if(ob->u_ldata)
    {
	FD_fax *f;
	f = ob->form->u_vdata;
	PrevFax (f, f->vdata);
    }
}

void button4_cb(FL_OBJECT *ob, long data)
{
    if(ob->u_ldata)
    {
	FD_fax *f;
	f = ob->form->u_vdata;
	PrevPage (f, f->vdata);
    }
}

void button5_cb(FL_OBJECT *ob, long data)
{
    if(ob->u_ldata)
    {
	FD_fax *f;
	f = ob->form->u_vdata;
	NextPage (f, f->vdata);
    }
}

void button6_cb(FL_OBJECT *ob, long data)
{
    if(ob->u_ldata)
    {
	FD_fax *f;
	f = ob->form->u_vdata;
	NextFax(f, f->vdata);
    }
}

void button7_cb(FL_OBJECT *ob, long data)
{
    if(ob->u_ldata)
    {
	extern void show_info(void);
	show_info();
    }
}

void vres_cb(FL_OBJECT *ob, long data)
{
    FD_fax *f;
    BITMAP *b;

    
    f = ob->form->u_vdata;
    b =  (BITMAP *) f->vdata;

    if(b->fn)
    {
	XFillRectangle(fl_get_display(), CANVID(f->canvas), b->sgc,
		   0, 0, b->width, b->height);
	
	FreeBitMap(f, b, 0);
	b->vres ^= 1;
	if(b->vres)
	{
	    b->width /= 2;
	    b->height /= 2;
	}
	else
	{
	    b->width *= 2;
	    b->height *= 2;
	}
	
	b->curx = b->cury = 0;
	b->xi = XCreateImage (fl_get_display(),
			      fl_state[fl_get_vclass()].xvinfo->visual,
			      1, XYBitmap, 0, 
			      b->data[b->vres], b->width, b->height, 8, 
			      b->width >> 3);
	XInitImage (b->xi);
	b->xi->bitmap_bit_order = MSBFirst;
	b->xi->byte_order = MSBFirst;
	b->pixmap = XCreatePixmap (fl_get_display(), 
				   CANVID(f->canvas),
				   b->width, b->height, 1);
	b->pgc = XCreateGC (fl_get_display(), b->pixmap, 0, 0);
	
	DrawImage(f);
	ResetAll(f,b);
    }
    else
    {
	b->vres ^= 1;
    }
}





